// the following line includes afxwin.h and ctl3dv2.h, too
#include "dpu.h"
#pragma hdrstop
#include "abtdlg.h"
// ------------------------------------------------------------------------- //
void getVersion( CString& Desc, CString& Prod, CString& Cpr, CString& Sn,
  CString& Ver, int& major, int& minor, int& build )
{
	DWORD hVer;
	DWORD versize;
	unsigned int strsize;
	char key[128], tstr[256];
	VS_FIXEDFILEINFO __far *fixbuf;
	char __far *strbuf;
	char __far *langbuf;
	void *vverbuf;
	void __far *verbuf;
	int mj, mi, bu;

	major = minor = build = -1;

	Sn = "<SerialNumber not available>";
	Cpr = "<LegalCopyright not available>";
	Prod = "<ProductName not available>";
	Desc = "<FileDescription not available>";
	Ver = "<FileVersion not available>";

	GetModuleFileName( AfxGetInstanceHandle(), tstr, sizeof( tstr ) );

	versize = GetFileVersionInfoSize( tstr, &hVer );
	if ( versize == 0L )
		goto fta;

	vverbuf = (void *) malloc( (int) versize );
	verbuf = (void __far *) vverbuf;
	if ( vverbuf == NULL )
		goto fta;

	if ( GetFileVersionInfo( tstr, hVer, versize, verbuf ) == 0 )
		goto fta;

	strcpy( key, "\\" );
	if ( VerQueryValue( verbuf, key,
		(void __far * __far *) &fixbuf, &strsize ) ) {
		mj = (int) HIWORD( fixbuf->dwFileVersionMS );
		mi = (int) LOWORD( fixbuf->dwFileVersionMS );
		bu = (int) HIWORD( fixbuf->dwFileVersionLS );
		sprintf( Ver.GetBuffer( 128 ), "%d.%02d.%02d", mj, mi, bu );
		Ver.ReleaseBuffer( -1 );
		major = mj; minor = mi; build = bu;
	}

	if ( VerQueryValue( verbuf, "\\VarFileInfo\\Translation",
	(void __far * __far *) &langbuf, &strsize ) == 0 || strsize == 0 )
		goto fta;

	sprintf( key, "\\StringFileInfo\\%04X%04X\\FileDescription",
	*((WORD __far *) langbuf), *(((WORD __far *) langbuf) + 1) );
	if ( VerQueryValue( verbuf, key,
		(void __far * __far *) &strbuf, &strsize ) ) {
		_fstrncpy( Desc.GetBuffer( strsize + 1 ), strbuf, strsize + 1 );
		Desc.ReleaseBuffer( -1 );
	}

	sprintf( key, "\\StringFileInfo\\%04X%04X\\ProductName",
	*((WORD __far *) langbuf), *(((WORD __far *) langbuf) + 1) );
	if ( VerQueryValue( verbuf, key,
		(void __far * __far *) &strbuf, &strsize ) ) {
		_fstrncpy( Prod.GetBuffer( strsize + 1 ), strbuf, strsize + 1 );
		Prod.ReleaseBuffer( -1 );
	}

	sprintf( key, "\\StringFileInfo\\%04X%04X\\LegalCopyright",
	*((WORD __far *) langbuf), *(((WORD __far *) langbuf) + 1) );
	if ( VerQueryValue( verbuf, key,
		(void __far * __far *) &strbuf, &strsize ) ) {
		_fstrncpy( Cpr.GetBuffer( strsize + 1 ), strbuf, strsize + 1 );
		Cpr.ReleaseBuffer( -1 );
	}

	sprintf( key, "\\StringFileInfo\\%04X%04X\\SerialNumber",
	*((WORD __far *) langbuf), *(((WORD __far *) langbuf) + 1) );
	if ( VerQueryValue( verbuf, key,
		(void __far * __far *) &strbuf, &strsize ) ) {
		_fstrncpy( Sn.GetBuffer( strsize + 1 ), strbuf, strsize + 1 );
		Sn.ReleaseBuffer( -1 );
	}

fta:
	if ( vverbuf != NULL )
		free( vverbuf );
}
// ------------------------------------------------------------------------- //
CAboutDlg::CAboutDlg( CWnd *parent ): CModalDialog( DLG_ABOUT, parent )
{
	m_parent = parent;
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
BOOL CAboutDlg::OnInitDialog()
{
	int i;
	CString Desc, Prod, Cpr, Sn, Ver;

	getVersion( Desc, Prod, Cpr, Sn, Ver, i, i, i );

	Ctl3dSubclassDlgEx( m_hWnd, CTL3D_ALL );
	SetDlgItemText( IDD_ABOUT_DESC, Desc );
	SetDlgItemText( IDD_ABOUT_PROD, Prod );
	SetDlgItemText( IDD_ABOUT_CPR, Cpr );
	SetDlgItemText( IDD_ABOUT_SN, Sn );
	SetDlgItemText( IDD_ABOUT_VER, Ver );

	CenterWindow();
	return TRUE;
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
void CAboutDlg::OnOK()
{
	EndDialog( IDOK );
}
// ------------------------------------------------------------------------- //
IMPLEMENT_DYNAMIC( CAboutDlg, CModalDialog )
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
BEGIN_MESSAGE_MAP( CAboutDlg, CModalDialog )
END_MESSAGE_MAP()
// ------------------------------------------------------------------------- //
