/*-------------------------------------------------------------------------*\
 |                                                                         |
 |                                                                         |
 |  CALLBACK.C - A Sample DLL Timer callback                               |
 |  Copyright (c) 1991 Microsoft Corporation. All rights reserved.         |
 |                                                                         |
\*-------------------------------------------------------------------------*/

#include <windows.h>
#include <mmsystem.h>
#include "timesmp.h"

/* a W4 warning killer */
#define NOREF(a)  {a=a;}

/*-------------------------------------------------------------------------*\
 |                                                                         |
 |  Function:   TimerCallBack                                              |
 |                                                                         |
 |  Purpose:    A pointer to this function is passed to timeSetEvent()     |
 |              and is called by Multimedia Windows when a timer event     |
 |              happens.                                                   |
 |                                                                         |
 |  Parameters: WORD wID     - The ID of the timer event.  This is the ID  |
 |                             returned by timeSetEvent().                 |
 |                                                                         |
 |              WORD wMsg    - Not used.                                   |
 |                                                                         |
 |              DWORD dwUser - User instance data supplied to the dwUser   |
 |                             parameter of timeSetEvent.  We use it here  |
 |                             to pass the HWND of the application to the  |
 |                             DLL for PostMessage().                      |
 |                                                                         |
 |              DWORD dw1    - Not used.                                   |
 |                                                                         |
 |              DWORD dw2    - Not used.                                   |
 |                                                                         |
\*-------------------------------------------------------------------------*/

void FAR PASCAL TimerCallBack(WORD wID, WORD wMsg,
                              DWORD dwUser, DWORD dw1, DWORD dw2)
   {
   DWORD dwTimeNow;

   /*  get the current time. timeGetTime() has less overhead than
    *  timeGetSystemTime().
    */
   dwTimeNow = timeGetTime();

   /* Post a message to our application.  dwUser has the app's hWnd */
   PostMessage((HWND)dwUser,WM_COMMAND,IDM_TIMER,dwTimeNow);

   return;

   NOREF(wID);
   NOREF(wMsg);
   NOREF(dw1);
   NOREF(dw2);
   }


BOOL FAR PASCAL LibMain(HANDLE hInstance, WORD wDataSeg, WORD cbHeap, 
                        LPSTR lpszCmdLine)
   {
   return TRUE;

   NOREF(hInstance);
   NOREF(wDataSeg);
   NOREF(cbHeap);
   NOREF(lpszCmdLine);
   }


int FAR PASCAL WEP(int nParameter)
   {
   return TRUE;

   NOREF(nParameter);
   }
