//////////////////////////////////////////////////////////////////////////////////
// CNewMem	: Drive de CMemory.h, gestion plus pointue de la mmoire
//////////////////////////////////////////////////////////////////////////////////
#include	<stdafx.h>
#include	<libgege\cmemory.h>
#include	<libgege\cnewmem.h>

//%%SrCtl:CNewMem%%


CNewMem::CNewMem	(DWORD pAlloc)	: CMemory (pAlloc)
	{
	Ptr=Start=NULL;
	PtrPos=0;
	}
	
CNewMem::CNewMem	()
	{
	Ptr=Start=NULL;
	PtrPos=0;
	}
	
CNewMem::~CNewMem	()
	{
	}
	
void FAR *CNewMem::GetDataPtr()
	{
	if	((!IsLocked())&&(GetHandle()!=NULL))
		{
		Start=(BYTE huge *)CMemory::GetDataPtr	();
		Ptr=Start;
		PtrPos=0;
		}
	return Start;
	}

BOOL	CNewMem::ReleaseDataPtr	()
	{
	BOOL	Ret;
	
	Ret=CMemory::ReleaseDataPtr();
	if	(Ret==TRUE)
		{
		Start=NULL;
		PtrPos=NULL;
		Ptr=NULL;
		}
	return Ret;
	}

BOOL	CNewMem::Realloc	(DWORD NewSize)
	{
	BOOL	Lock=FALSE,Ret=TRUE;
	DWORD	Pos;
	
	if	(IsLocked())
		{
		Lock=TRUE;
		Pos=GetCurrentPos();
		ReleaseDataPtr();
		}
	
	Ret=CMemory::Realloc	(NewSize);
	if	((Ret==TRUE)&&(Lock==TRUE))
		{
		GetDataPtr();
		MoveTo	(Pos);
		}
	return Ret;
	}

BOOL	CNewMem::Free	()
	{
	BOOL Ret;
	
	Ret=CMemory::Free();
	Start=Ptr=NULL;
	PtrPos=0;
	return Ret;
	}

BOOL	CNewMem::LoadFile	(LPCSTR FileName)
	{
	BOOL Ret=TRUE;
	CStdioFile Fich	(FileName,CFile::modeRead|CFile::typeBinary);
	
	DWORD Taille=Fich.GetLength();
	if	(Realloc(Taille))
		{
		Start=(BYTE huge *)GetDataPtr();
		if	(Fich.ReadHuge(Start,Taille)!=Taille)
			Ret=FALSE;
		ReleaseDataPtr();
		Start=NULL;
		}
	else
		Ret=FALSE;
	Fich.Close();
	return Ret;
	}
	
BOOL	CNewMem::WriteFile	(LPCSTR FileName)
	{
	BOOL Ret=TRUE;
	CStdioFile Fich	(FileName,CFile::modeWrite|CFile::modeCreate|CFile::typeBinary);
	
	DWORD Taille=GetDataSize();
	Start=(BYTE huge *)GetDataPtr();
	Fich.WriteHuge(Start,Taille);
	ReleaseDataPtr();
	Start=NULL;
	Fich.Close();
	return Ret;
	}
	
void CNewMem::ResetPtr	()
	{
	ASSERT	(Start!=NULL);
	Ptr=Start;
	PtrPos=0;
	}
	
BYTE huge *CNewMem::GetCurrentPtr	()
	{
	ASSERT	(Ptr!=NULL);
	return Ptr;
	}
	
BYTE huge *CNewMem::GetStartPtr		()
	{
	ASSERT	(Start!=NULL);
	return Start;
	}
	
DWORD	CNewMem::GetCurrentPos	()
	{
	return PtrPos;
	}


BOOL CNewMem::Search	(BYTE *ACherche)		//BYTE [4], Quatres caractres
	{
	DWORD Max;
	BYTE	bPremier=ACherche[0];
	
	Max=GetDataSize();
	if	(Max<4)	return NULL;
	for	(PtrPos;PtrPos<Max-3;PtrPos++,Ptr++)
		{
		if	((*Ptr==bPremier)&&(*(Ptr+1)==ACherche[1])&&(*(Ptr+2)==ACherche[2])&&(*(Ptr+3)==ACherche[3]))
			return TRUE;
		}
			
	return FALSE;
	}

BOOL CNewMem::Search2Bytes	(BYTE *ACherche)		//BYTE [2], Deux caractres
	{
	DWORD Max;
	BYTE	bPremier=ACherche[0];
	
	Max=GetDataSize();
	if	(Max<2)	return NULL;
	for	(PtrPos;PtrPos<Max-1;PtrPos++,Ptr++)
		{
		if	((*Ptr==bPremier)&&(*(Ptr+1)==ACherche[1]))
			return TRUE;
		}
			
	return FALSE;
	}


BOOL CNewMem::GotoEndLine	()
	{
	char EndLine[2]={13,10};
	
	return	Search2Bytes	((BYTE *)EndLine);
	}

BOOL CNewMem::GotoNextLine	()
	{
	char EndLine[2]={13,10};
	BOOL Ret;
	
	Ret = Search2Bytes	((BYTE *)EndLine);
	if	(Ret)
		MoveTo	(GetCurrentPos()+2);
	return Ret;
	}

BOOL CNewMem::GotoBeginLine	()
	{
	char EndLine[2]={13,10};
	BOOL Ret;

	Ret = SearchBack2Bytes	((BYTE *)EndLine);
	if	(Ret)
		MoveTo (GetCurrentPos()+2);
	return Ret;
	}

BOOL CNewMem::SearchBack2Bytes	(BYTE *ACherche)
	{
	DWORD Max;
	BYTE	bPremier=ACherche[1];
	
	Max=GetDataSize();
	if	(Max<2)	return NULL;
	for	(PtrPos;PtrPos>0;PtrPos--,Ptr--)
		{
		if	((*Ptr==bPremier)&&(*(Ptr-1)==ACherche[0]))
			{
			Ptr --;
			PtrPos--;
			return TRUE;
			}
		}
			
	return FALSE;
	}

BOOL CNewMem::Search	(CString	&ACherche)
	{
	DWORD Max;
	BYTE	bPremier=ACherche[0];
	int	Taille;
	
	Max=GetDataSize();
    Taille=ACherche.GetLength();
	if	((Max<(DWORD)Taille)||(Taille==0))	return FALSE;
	
	for	(PtrPos;PtrPos<Max-Taille-1;PtrPos++,Ptr++)
		{
		if	((*Ptr)==bPremier)
			{
//				bOthers=(BYTE)ACherche.GetAt(i);
//			    if	(*(Ptr+i)!=bOthers)
//			    	break;
			if	(_strnicmp ((const char *)Ptr,ACherche,Taille)==0)
				return TRUE;
			else
				{
				PtrPos++;
				Ptr++;
				}
			}
		}
			
	return FALSE;
	}


BOOL CNewMem::CopyTo	(CNewMem&	To,DWORD Deb,DWORD Fin)
	{
	BOOL	Ret=TRUE;
    BOOL	bLock=TRUE;
	BYTE huge *Temp;
	
	if	(Fin==0xFFFFFFFF)	Fin=GetDataSize();
	Ret=To.ReallocToAdd	(Fin-Deb);
	
	if	(!To.IsLocked())
		{
		bLock=FALSE;
		To.GetDataPtr();
		}
	ASSERT	(Start!=NULL);	//Doit tre lock
	
	Temp=(BYTE huge *)&Start[Deb];
	hmemcpy	(To.GetCurrentPtr(),Temp,Fin-Deb);
	MoveTo	(Fin);
    To.MoveTo	(To.GetCurrentPos()+Fin-Deb);
    
	if	(!bLock)
		To.ReleaseDataPtr();
	
	return TRUE;
	}


BOOL	CNewMem::MoveTo	(DWORD To)
	{
	if (!IsLocked())	return FALSE;
	
	Ptr=Start+To;
	PtrPos=To;
	return TRUE;
	}

BOOL	CNewMem::ReallocToAdd	(DWORD ToAdd)
	{
	BOOL Ret=TRUE;
	
	if	((GetDataSize()<ToAdd)||(GetDataSize()-GetCurrentPos()<ToAdd))
		{
			//Essaie d'en copier plus que la destination.
			//Agrandi la destination
		DWORD Pos;
		BOOL  bLock=FALSE;
		
		if	(IsLocked ())
			{
			bLock=TRUE;
			Pos=GetCurrentPos();
			ReleaseDataPtr();
			}
		else	Pos=0;
			
		if (Realloc(GetDataSize()+(ToAdd-(GetDataSize()-Pos)))==FALSE)
			{
			TRACE("Err: ReallocToAdd , pas assez de mem.");
			Ret=FALSE;
			}
		if	(bLock)
			{
			GetDataPtr();
			MoveTo	(Pos);
			}
		}
	
	return Ret;
	}
	
BOOL	CNewMem::AddString		(CString &ToAdd)
	{
	DWORD	Taille;
	
	Taille=ToAdd.GetLength();
	if	(ReallocToAdd(Taille)==FALSE)	return FALSE;
	
	BYTE huge *PtrTemp;
	
	PtrTemp=GetCurrentPtr();
	if	(PtrTemp!=NULL)
		hmemcpy	((void huge *)PtrTemp,(void huge *)(const char *)ToAdd,ToAdd.GetLength());
	else
		return FALSE;
	MoveTo	(GetCurrentPos()+ToAdd.GetLength());
	return TRUE;
	}

BOOL CNewMem::ReadStringUntil	(CString &ReadTo, BYTE EndChar, BOOL ToEndLine)	//Lit un CString jusqu'au char ou fin de ligne
	{
	DWORD		EndPos, CurPos;
	CString	ToSearch = EndChar;
	
	CurPos = GetCurrentPos();
	if	(Search	(ToSearch))
		{
		DWORD	StrLength;
		EndPos = GetCurrentPos();
		MoveTo	(CurPos);
			//Vrifie si le endchar est bien avant la ligne
		if	(ToEndLine)
			{
			GotoEndLine ();
			if	(GetCurrentPos () < EndPos)
				return	FALSE;
			}
		MoveTo	(CurPos);
		StrLength = EndPos - CurPos;
		memcpy	(ReadTo.GetBufferSetLength((int)StrLength +1), GetCurrentPtr(),(int) StrLength);
		ReadTo.ReleaseBuffer((int)StrLength);
		MoveTo	(EndPos + 1);
		return	TRUE;
		}
	return	FALSE;
	}

//%%EndSrCtl:CNewMem%%


	