.386p
;
;   Call Struct
;
CALLSTRUCT STRUC
RealMode_DI     dw  ?
                dw  ?
RealMode_SI     dw  ?
                dw  ?
RealMode_BP     dw  ?
                dw  ?
Reserved        dd  ?
RealMode_BX     dw  ?
                dw  ?
RealMode_DX     dw  ?
                dw  ?
RealMode_CX     dw  ?
                dw  ?
RealMode_AX     dw  ?
                dw  ?
RealMode_FL     dw  ?
RealMode_ES     dw  ?
RealMode_DS     dw  ?
RealMode_FS     dw  ?
RealMode_GS     dw  ?
RealMode_IP     dw  ?
RealMode_CS     dw  ?
RealMode_SP     dw  ?
RealMode_SS     dw  ?
CALLSTRUCT ENDS
CALLSIZE EQU SIZE CALLSTRUCT

;//_DATA   segment
;//Int1B_CallStruc db CALLSIZE DUP (0)
;//_DATA   ends

SUCCESS EQU 1
FAILURE EQU 0

SELECTOR    EQU [bp+6]
RETVAL      EQU [bp+6]
BASE        EQU [bp+8]
LIMIT       EQU [bp+8]

_TEXT32A        SEGMENT DWORD USE16 PUBLIC 'CODE'
_TEXT32A        ENDS

        assume  cs:_TEXT32A

_TEXT32A  SEGMENT
;******************************************************************************
;
;   Call:   (WORD) sel = DPMI_AllocSelector ();
;
PUBLIC _DPMI_AllocSelector
_DPMI_AllocSelector PROC FAR
    mov     ax, 0Ah
    mov     bx, ds
    int     31h
    jnc     DPMI_AS_Done
    xor     ax, ax

DPMI_AS_Done:
    ret
_DPMI_AllocSelector ENDP
;******************************************************************************
;
;   Call:   (WORD) sel = DPMI_FreeSelector (WORD sel);
;
;   Returns:
;       0 - Fail
;       1 - Success
;
PUBLIC _DPMI_FreeSelector
_DPMI_FreeSelector PROC FAR
    push    bp
    mov     bp, sp
    mov     ax, 1
    mov     bx, SELECTOR
    int     31h
    jnc     DPMI_FS_Okay
    mov     ax, FAILURE
    jmp     DPMI_FS_Done

DPMI_FS_Okay:
    mov     ax, SUCCESS                 ; Return function worked

DPMI_FS_Done:
    pop     bp
    ret
_DPMI_FreeSelector ENDP

;******************************************************************************
;
;   Call:   (WORD) sel = DPMI_SetSelectorBase (WORD sel, DWORD base)
;
PUBLIC _DPMI_SetSelectorBase
_DPMI_SetSelectorBase PROC FAR
    push    bp
    mov     bp, sp
    mov     ax, 7
    mov     bx, SELECTOR
    mov     cx, WORD PTR BASE+2
    mov     dx, WORD PTR BASE
    int     31h
    jnc     DPMI_SSB_okay
    mov     ax, FAILURE
    jmp     DPMI_SSB_Done

DPMI_SSB_okay:
    mov     ax, SUCCESS

DPMI_SSB_Done:
    pop     bp
    ret
_DPMI_SetSelectorBase ENDP

;******************************************************************************
;
;   Call:   (WORD) sel = DPMI_SetSelectorLimit (WORD sel, DWORD limit)
;
PUBLIC _DPMI_SetSelectorLimit
_DPMI_SetSelectorLimit PROC FAR
    push    bp
    mov     bp, sp
    mov     ax, 8
    mov     bx, SELECTOR
    mov     cx, WORD PTR LIMIT+2
    mov     dx, WORD PTR LIMIT
    int     31h
    jnc     DPMI_SSL_okay
    mov     ax, FAILURE
    jmp     DPMI_SSL_Done

DPMI_SSL_okay:
    mov     ax, SUCCESS

DPMI_SSL_Done:
    pop     bp
    ret
_DPMI_SetSelectorLimit ENDP

;******************************************************************************
;
;   Call:   (DWORD) base = DPMI_GetSelectorBase (WORD sel)
;
PUBLIC _DPMI_GetSelectorBase
_DPMI_GetSelectorBase PROC FAR
    push    bp
    mov     bp, sp
    mov     ax, 6
    mov     bx, SELECTOR
    int     31h
    jnc     DPMI_GSB_okay
    xor     ax, ax
    xor     dx, dx
    jmp     DPMI_GSB_Done

DPMI_GSB_okay:
    mov     ax, dx
    mov     dx, cx

DPMI_GSB_Done:
    pop     bp
    ret
_DPMI_GetSelectorBase ENDP

;******************************************************************************
;
;   Call:   (WORD) limit = DPMI_GetSelectorLimit (WORD sel)
;
PUBLIC _DPMI_GetSelectorLimit
_DPMI_GetSelectorLimit PROC FAR
    push    bp
    mov     bp, sp
    mov     ax, SELECTOR
    or      ax, ax
    jz      DPMI_GSL_Done
    int 1
    lsl     ax, SELECTOR

DPMI_GSL_Done:
    pop     bp
    ret
_DPMI_GetSelectorLimit ENDP


;******************************************************************************
;******************************************************************************
;
;   Call:   (WORD) active = DPMI_Active (void)
;
PUBLIC _DPMI_Active
_DPMI_Active  PROC FAR
    mov     ax, 1686h
    int     2Fh
    not     ax
    ret
_DPMI_Active ENDP

;******************************************************************************
;
;   Call:   DPMI_DOS_Exit (WORD retval)
;
PUBLIC _DPMI_DOS_Exit
_DPMI_DOS_Exit PROC FAR
    push    bp
    mov     bp, sp
    mov     ah, 4Ch
    mov     al, BYTE PTR RETVAL
    int     21h
_DPMI_DOS_Exit ENDP

;******************************************************************************
;
;   Call:   DPMI_Ctrl_Break_Init
;
PUBLIC _Ctrl_Break_Init
_Ctrl_Break_Init PROC FAR
    push    ds
    push    cs
    pop     ds
    mov     dx, OFFSET My_PM_Int1B
    mov     ax,251Bh
    int     21h
    pop     ds
    ret
_Ctrl_Break_Init ENDP

CtrlBreak   db  0

PUBLIC My_PM_Int1B
My_PM_Int1B PROC NEAR
    pusha
    push    ds
    push    es
;
;   Create CS alias for CS variables
;
    mov     ax, 0Ah
    mov     bx, cs
    int     31h
    jc      Int1b_Done
    mov     ds, ax
    mov     ds:CtrlBreak, 0FFh
    mov     ax, 1                       ; Free the selector after use
    mov     bx, ds
    int     31h

Int1b_Done:
    pop     es
    pop     ds
    popa
    iret
My_PM_Int1B ENDP

PUBLIC _GetCtrlBreak
_GetCtrlBreak PROC FAR
    push    ds
    push    es
;
;   Create CS alias for CS variables
;
    mov     ax, 0Ah
    mov     bx, cs
    int     31h
    jc      checkInt1b_Done
    mov     ds, ax
    xor     ax,ax
    mov     al, CtrlBreak
    push    ax
    mov     ax, 1                       ; Free the selector after use
    mov     bx, ds
    int     31h
    pop     ax

checkInt1b_Done:
    pop     es
    pop     ds
    ret
_GetCtrlBreak ENDP

;int1B_Real_Seg   dw  0
;int1B_Real_Off   dw  0
;int21_PM_Vector  dd  0
;Int1B_CallStruc  db CALLSIZE DUP (0)

;PUBLIC _DPMI_Ctrl_Break_Init
;_DPMI_Ctrl_Break_Init PROC FAR
;    push    ds
;    push    ds
;    pop     es
;;
;;   Create CS alias for CS variables
;;
;    mov     ax, 0Ah
;    mov     bx, cs
;    int     31h
;    jc      Break_Init_Error
;    mov     ds, ax                      ; Alias to code segment
;    ASSUME  ds: _TEXT32A
;;
;;   Get realmode int1B
;;
;    mov     ax, 200h
;    mov     bl, 1Bh
;    int     31h
;    jc      Break_Init_Error
;    mov     Int1B_Real_Seg, cx
;    mov     Int1B_Real_Off, dx
;;
;;   Allocate a real mode call-back
;;
;    push    ds
;    push    ds
;    pop     es
;    mov     ax, 303h
;    mov     bx, cs
;    mov     ds, bx
;    mov     esi, OFFSET My_Int1B
;    mov     edi, OFFSET _TEXT32A:Int1B_CallStruc
;    int     31h
;    jc      loadpop_error
;;
;;   Set RealMode interrupt
;;
;    mov     ax, 201h
;    mov     bx, 1Bh
;    int     31h
;
;loadpop_error:
;    pop     ds
;    jc      Break_Init_Error
;;
;;   Get protected mode int21
;;
;    push    ds
;    mov     ax,3521h
;    int     21h
;    mov     WORD PTR int21_PM_Vector+2, es
;    mov     WORD PTR int21_PM_Vector, bx
;    push    cs
;    pop     ds
;    mov     edx, OFFSET My_PM_Int21
;    mov     ax,2521h
;    int     21h
;    mov     ax, 1                       ; Free the selector after use
;    pop     bx
;    int     31h
;    xor     ax,ax
;    jmp     Break_Init_ok
;
;Break_Init_Error:
;    mov     ax, 1
;
;Break_Init_ok:
;    pop     ds
;    ret
;_DPMI_Ctrl_Break_Init ENDP

;;
;;   On entry,
;;       DS:SI --> RealMode SS:SP
;;       ES:DI --> RealMode Call Struct
;;
;;
;My_Int1B PROC NEAR
;int 1
;        push    ax
;        int 1Bh                         ; Protected mode int 1Bh
;        mov     ax, cs:[Int1B_Real_Seg]
;        mov     es:[di.RealMode_CS],ax
;        mov     ax, cs:[Int1B_Real_Off]
;        mov     es:[di.RealMode_IP],ax
;        pop     ax
;        iret
;My_Int1B ENDP

;;
;;   On entry,
;;       DS:SI --> RealMode SS:SP
;;       ES:DI --> RealMode Call Struct
;;
;;
;My_PM_Int21 PROC NEAR
;        push    ax
;        cmp     ah, 4Ch
;        jnz     My_int21_return
;;
;;   Restore RealMode int1B and int21
;;
;        push    bx
;        push    cx
;        push    dx
;        mov     ax, 201h
;        mov     bx, 1Bh
;        mov     cx, cs:[Int1B_Real_Seg]
;        mov     dx, cs:[Int1B_Real_Off]
;        int     31h
;        mov     ax, 2521h
;        push    ds
;        mov     dx, WORD PTR cs:[Int21_PM_Vector+2]
;        push    dx
;        mov     dx, WORD PTR cs:[Int21_PM_Vector]
;        pop     ds
;        int     21h
;        pop     ds
;        pop     dx
;        pop     cx
;        pop     bx
;
;My_int21_return:
;        pop     ax
;        jmp     DWORD PTR cs:Int21_PM_Vector
;My_PM_Int21 ENDP


_TEXT32A ENDS
    END
