#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <dos.h>
#include <cdate.inc>
#include <types.h>
#include <vxdfns.h>
#include "vxdcalls.h"
#include "dpmi.h"

DWORD DPMI_Phys_To_Lin(DWORD phys_addr, DWORD num_bytes)
{
    _asm push si
    _asm push di
    _asm mov ax, 0800h
    _asm mov bx, word ptr [phys_addr+2]
    _asm mov cx, word ptr [phys_addr]
    _asm mov si, word ptr [num_bytes+2]
    _asm mov di, word ptr [num_bytes]
    _asm int 31h
    _asm jc error
    _asm mov dx, bx
    _asm mov ax, cx
    _asm jmp short done
error:
    _asm xor ax, ax
    _asm xor dx, dx
done:
    _asm pop di
    _asm pop si
    // return value in DX:AX
}

/*                                                                            */
/*  Return a far pointer to Linear address space                              */
/*                                                                            */
/*                                                                            */
void far *Map_Linear(DWORD lin_addr, DWORD num_bytes)
{
    WORD sel;

    /* allocate a selector similar to our current DS
       (i.e., a data selector) */
    if ((sel = DPMI_AllocSelector()) == 0)
        fail("Cannot allocate a selector!");

    /* set the base and limit of the new selector */
    DPMI_SetSelectorBase(sel, lin_addr);
    DPMI_SetSelectorLimit(sel, num_bytes - 1);

    /* turn into a far pointer */
    return FP_MAKE (sel, 0);
}
/*                                                                            */
/*  Free the selector allocated from Map_Linear()                             */
/*                                                                            */
void Free_Mapped_Linear(void far *fp)
{
    DPMI_FreeSelector(FP_SEG(fp));
}
