// mainfrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "ruler.h"

#include "mainfrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

// IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
    //{{AFX_MSG_MAP(CMainFrame)
    ON_WM_ERASEBKGND()
    ON_WM_PAINT()
    ON_WM_LBUTTONDOWN()
    ON_WM_LBUTTONUP()
    ON_WM_MOUSEMOVE()
    ON_WM_LBUTTONDBLCLK()
    ON_WM_RBUTTONDOWN()
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
    m_bIsHorizontal = TRUE;
    m_bCaptured = FALSE;
}

CMainFrame::~CMainFrame()
{
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
    CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
    CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

BOOL CMainFrame::OnEraseBkgnd(CDC* pDC)
{
    RECT rc;
    CBrush brBk(RGB(128,128,128));
    GetClientRect(&rc);
    pDC->FillRect(&rc, &brBk);
    return TRUE; // say we did the erase
}

void CMainFrame::OnPaint()
{
    CPaintDC dc(this); // device context for painting
    CBrush brWh(RGB(255,255,255)); // white brush
    CPen penBk(PS_SOLID, 1, RGB(0,0,0)); // black pen
    CPen *ppenOld;
    RECT rcClient, rcFill, rcClip;
    int x, h, y, w;

    // Get the client rectangle size and the current clip box
    GetClientRect(&rcClient);
    dc.GetClipBox(&rcClip);

    // Shrink the x dimension of the client rect to fit the clip box
    // so we don't needlessly draw areas we don't have to.
    if (m_bIsHorizontal) {
        rcClient.left = max(rcClient.left, rcClip.left);
        rcClient.right = min(rcClient.right, rcClip.right);
    } else {
        rcClient.top = max(rcClient.top, rcClip.top);
        rcClient.bottom = min(rcClient.bottom, rcClip.bottom);
    }

    // paint in the white bars
    rcFill = rcClient;
    if (m_bIsHorizontal) {
        h = (rcClient.bottom - rcClient.top) / 12;
        rcFill.bottom = rcClient.top + h;
        dc.FillRect(&rcFill, &brWh);
        rcFill.top = rcClient.bottom - h;
        rcFill.bottom = rcClient.bottom;
        dc.FillRect(&rcFill, &brWh);
    } else {
        w = (rcClient.right - rcClient.left) / 12;
        rcFill.right = rcClient.left + w;
        dc.FillRect(&rcFill, &brWh);
        rcFill.left = rcClient.right - w;
        rcFill.right = rcClient.right;
        dc.FillRect(&rcFill, &brWh);
    }

    //  draw the lines
    ppenOld = dc.SelectObject(&penBk);
    if (m_bIsHorizontal) {
        for (x = rcClient.left; x <= rcClient.right; x++) {
            if (x % 100 == 0) {
                dc.MoveTo(x, rcClient.top);
                dc.LineTo(x, rcClient.bottom);
            } else if (x % 10 == 0) {
                h = (rcClient.bottom - rcClient.top) / 3;
                dc.MoveTo(x, rcClient.top);
                dc.LineTo(x, rcClient.top + h);
                dc.MoveTo(x, rcClient.bottom - h);
                dc.LineTo(x, rcClient.bottom);
            } else if ((x & 1) == 0) {
                h = (rcClient.bottom - rcClient.top) / 6;
                dc.MoveTo(x, rcClient.top);
                dc.LineTo(x, rcClient.top + h);
                dc.MoveTo(x, rcClient.bottom - h);
                dc.LineTo(x, rcClient.bottom);
            }
        }
    } else {
        for (y = rcClient.top; y <= rcClient.bottom; y++) {
            if (y % 100 == 0) {
                dc.MoveTo(rcClient.left, y);
                dc.LineTo(rcClient.right, y);
            } else if (y % 10 == 0) {
                w = (rcClient.right - rcClient.left) / 3;
                dc.MoveTo(rcClient.left, y);
                dc.LineTo(rcClient.left + w, y);
                dc.MoveTo(rcClient.right - w, y);
                dc.LineTo(rcClient.right, y);
            } else if ((y & 1) == 0) {
                w = (rcClient.right - rcClient.left) / 6;
                dc.MoveTo(rcClient.left, y);
                dc.LineTo(rcClient.left + w, y);
                dc.MoveTo(rcClient.right - w, y);
                dc.LineTo(rcClient.right, y);
            }
        }

    }
    dc.SelectObject(ppenOld);
}

void CMainFrame::OnLButtonDown(UINT nFlags, CPoint point)
{
    if (!m_bCaptured) {
        SetCapture();
        m_bCaptured = TRUE;
        m_ptMouseHit = point;
    }
}

void CMainFrame::OnLButtonUp(UINT nFlags, CPoint point)
{
    if (m_bCaptured) {
        ReleaseCapture();
        m_bCaptured = FALSE;
    }
}

void CMainFrame::OnMouseMove(UINT nFlags, CPoint point)
{
    if (m_bCaptured) {
        
        // convert mouse co-ords to screen coords
        ClientToScreen(&point);
        // Move the window to the new position
        SetWindowPos(NULL,
                     point.x - m_ptMouseHit.x,
                     point.y - m_ptMouseHit.y,
                     0,
                     0,
                     SWP_NOSIZE | SWP_NOZORDER);
    }
}

void CMainFrame::OnLButtonDblClk(UINT nFlags, CPoint point)
{
    // Flip from horizontal to verticle or vise versa

    ClientToScreen(&point);    // screen co-ords of hit
    RECT rcWnd;
    GetWindowRect(&rcWnd);      // get the current position of the window
    RECT rcNew;
    m_bIsHorizontal = !m_bIsHorizontal;
    if (m_bIsHorizontal) {

        rcNew.top = point.y - DEFAULT_HEIGHT / 2;
        rcNew.left = 0;
        rcNew.bottom = rcNew.top + DEFAULT_HEIGHT;
        rcNew.right = GetSystemMetrics(SM_CXSCREEN);
     } else {

        rcNew.top = 0;
        rcNew.left = point.x - DEFAULT_WIDTH / 2;
        rcNew.bottom = GetSystemMetrics(SM_CYSCREEN);
        rcNew.right = rcNew.left + DEFAULT_WIDTH;
    }
    SetWindowPos(NULL,
                 rcNew.left,
                 rcNew.top,
                 rcNew.right - rcNew.left + 1,
                 rcNew.bottom - rcNew.top + 1,
                 SWP_NOZORDER);

}

void CMainFrame::OnRButtonDown(UINT nFlags, CPoint point)
{
    CMenu Menu;
    Menu.LoadMenu(IDR_MAINFRAME);
    CMenu *pPopup = Menu.GetSubMenu(0);
    ClientToScreen(&point);
    pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
                           point.x, point.y,
                           this);
}
