#include <windows.h>
#include <stdio.h>
#include <stdarg.h>

#define API WINAPI

#include "winnet.h"
#include "nddeapi.h"

#include "myndde.h"

// !!!SEE .DEF FILE!!!  ==---> IMPORTS USER.WNETGETCAPS

#define nLocalBuf 512

UINT WINAPI __export MyWNetServerBrowseDialog(	HWND hwndParent, 
																LPSTR lpszSectionName,
																LPSTR lpszBuffer )
{
	HINSTANCE hinstNetDriver ;
	LPWNETSERVERBROWSEDIALOG lpDialogAPI ;

	hinstNetDriver = (HINSTANCE) WNetGetCaps(0xFFFF) ;
	if (hinstNetDriver == NULL)
	{
		// no network driver loaded
	  return MYERR_NODRIVER ;
	}
	else
	{
		lpDialogAPI = (LPWNETSERVERBROWSEDIALOG) GetProcAddress(
								hinstNetDriver, (LPSTR) ORD_WNETSERVERBROWSEDIALOG) ;
							
		if (lpDialogAPI == NULL)
		{
			// Current installed network doesn't support this API
			return MYERR_NOTSUPPORT ;
		}
		else
		{
			return (*lpDialogAPI)(	hwndParent, lpszSectionName, 
											lpszBuffer, MAX_USERNAME+1, 0L) ;								
		}
	}
}

UINT WINAPI __export 
MyI_ConnectionDialog(	HWND hwndParent, 
								WORD iType )
{
	HINSTANCE hinstNetDriver ;
	LPI_CONNECTIONDIALOG lpDialogAPI ;

	hinstNetDriver = (HINSTANCE) WNetGetCaps(0xFFFF) ;
	if (hinstNetDriver == NULL)
	{
		// no network driver loaded
	  return MYERR_NODRIVER ;
	}
	else
	{
		lpDialogAPI = (LPI_CONNECTIONDIALOG) GetProcAddress(
								hinstNetDriver, (LPSTR) ORD_I_CONNECTIONDIALOG) ;
							
		if (lpDialogAPI == NULL)
		{
			// Current installed network doesn't support this API
			return MYERR_NOTSUPPORT ;
		}
		else
		{
			(*lpDialogAPI)(	hwndParent, iType ) ;
			return WN_SUCCESS ; 
		}
	}
}

UINT WINAPI __export MyI_ConnectDialog(	HWND hwndParent, 
														WORD iType )
{
	HINSTANCE hinstNetDriver ;
	LPI_CONNECTDIALOG lpDialogAPI ;

	hinstNetDriver = (HINSTANCE) WNetGetCaps(0xFFFF) ;
	if (hinstNetDriver == NULL)
	{
		// no network driver loaded
	  return MYERR_NODRIVER ;
	}
	else
	{
		lpDialogAPI = (LPI_CONNECTDIALOG) GetProcAddress(
								hinstNetDriver, (LPSTR) ORD_I_CONNECTDIALOG) ;
							
		if (lpDialogAPI == NULL)
		{
			// Current installed network doesn't support this API
			return MYERR_NOTSUPPORT ;
		}
		else
		{
			(*lpDialogAPI)(	hwndParent, iType ) ;
			return WN_SUCCESS ; 
		}
	}
}


///////////////////////////////////////////////////////////////////////
//
// TRACE() - does a printf to the debug monitor
// -------
//
void __export FAR CDECL trace(LPCSTR pszFormat, ...)
{
	int nBuf ;
	char szBuffer[nLocalBuf] ;
	
	va_list args ;
	va_start(args, pszFormat) ;
	
	nBuf = vsprintf(szBuffer, pszFormat, args) ;
	
	OutputDebugString(szBuffer) ;	
}
