// Windows Picture Button Control Test Program

#define OEMRESOURCE 1
#include <windows.h>

extern "C" {
  long far pascal _export WndProc(HWND, UINT, WORD, LONG);
  int pascal WinMain(HINSTANCE, HINSTANCE, LPSTR, int);
}

static struct
{
  long number;
  char *name;
} OBM[] =
{
  {OBM_CLOSE,        "OBM_CLOSE"},
  {OBM_UPARROW,      "OBM_UPARROW"},
  {OBM_DNARROW,      "OBM_DNARROW"},
  {OBM_RGARROW,      "OBM_RGARROW"},
  {OBM_LFARROW,      "OBM_LFARROW"},
  {OBM_REDUCE,       "OBM_REDUCE"},
  {OBM_ZOOM,         "OBM_ZOOM"},
  {OBM_RESTORE,      "OBM_RESTORE"},
  {OBM_REDUCED,      "OBM_REDUCED"},
  {OBM_ZOOMD,        "OBM_ZOOMD"},
  {OBM_RESTORED,     "OBM_RESTORED"},
  {OBM_UPARROWD,     "OBM_UPARROWD"},
  {OBM_DNARROWD,     "OBM_DNARROWD"},
  {OBM_RGARROWD,     "OBM_RGARROWD"},
  {OBM_LFARROWD,     "OBM_LFARROWD"},
  {OBM_MNARROW,      "OBM_MNARROW"},
  {OBM_COMBO,        "OBM_COMBO"},
  {OBM_UPARROWI,     "OBM_UPARROWI"},
  {OBM_DNARROWI,     "OBM_DNARROWI"},
  {OBM_RGARROWI,     "OBM_RGARROWI"},
  {OBM_LFARROWI,     "OBM_LFARROWI"},
  {OBM_OLD_CLOSE,    "OBM_OLD_CLOSE"},
  {OBM_SIZE,         "OBM_SIZE"},
  {OBM_OLD_UPARROW,  "OBM_OLD_UPARROW"},
  {OBM_OLD_DNARROW,  "OBM_OLD_DNARROW"},
  {OBM_OLD_RGARROW,  "OBM_OLD_RGARROW"},
  {OBM_OLD_LFARROW,  "OBM_OLD_LFARROW"},
  {OBM_BTSIZE,       "OBM_BTSIZE"},
  {OBM_CHECK,        "OBM_CHECK"},
  {OBM_CHECKBOXES,   "OBM_CHECKBOXES"},
  {OBM_BTNCORNERS,   "OBM_BTNCORNERS"},
  {OBM_OLD_REDUCE,   "OBM_OLD_REDUCE"},
  {OBM_OLD_ZOOM,     "OBM_OLD_ZOOM"},
  {OBM_OLD_RESTORE,  "OBM_OLD_RESTORE",}
};


long far pascal _export WndProc(HWND hwnd, UINT message, WORD wParam,
  LONG lParam)
{
  switch (message)
  {
    case WM_CREATE:
      return 0;
    case WM_COMMAND:
      switch(wParam)
      {
        case 101:
          DestroyWindow(hwnd);
          return 0;
        case 102:
        {
          static unsigned i;
          HBITMAP bitmap = LoadBitmap(NULL, (const char far *) OBM[i].number);
          SendDlgItemMessage(hwnd, 101, BM_SETSTYLE, 0,
            MAKELPARAM(bitmap, bitmap));
          SetDlgItemText(hwnd, 106, OBM[i].name);
          if (++i == sizeof(OBM)/sizeof(OBM[0]))
            i = 0;
          return 0;
        }
        case 105:
        {
          static BOOL enabled = TRUE;
          enabled = !enabled;
          EnableWindow(GetDlgItem(hwnd, 104), enabled);
          return 0;
        }
      }
      break;
    case WM_CLOSE:
      DestroyWindow(hwnd);
      return 0;
    case WM_DESTROY:
      PostQuitMessage(0);
      return 0;
  }
  return DefDlgProc (hwnd, message, wParam, lParam);
}

#pragma argsused
int pascal WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    LPSTR lpszCmdLine, int nCmdShow)
{
    HWND hwnd;
    MSG msg;

    if (!hPrevInstance)
    {
      WNDCLASS wndclass;
      wndclass.style = 0;
      wndclass.lpfnWndProc = (WNDPROC) WndProc;
      wndclass.cbClsExtra = 0;
      wndclass.cbWndExtra = DLGWINDOWEXTRA;
      wndclass.hInstance = hInstance;
      wndclass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
      wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
      wndclass.hbrBackground = NULL;
      wndclass.lpszMenuName = NULL;
      wndclass.lpszClassName = "PBUTTONTEST";
      RegisterClass (&wndclass);
    }

    hwnd = CreateDialog(hInstance, "PBUTTONTEST", 0, NULL);

    SetFocus(GetDlgItem(hwnd, 102));
    SendDlgItemMessage(hwnd, 101, BM_SETSTATE, (WPARAM) GetDlgItem(hwnd, 107),
      (LPARAM)(char far *) "Terminate test");
    SendDlgItemMessage(hwnd, 102, BM_SETSTATE, (WPARAM) GetDlgItem(hwnd, 107),
      (LPARAM)(char far *) "Show OBM bitmaps");
    SendDlgItemMessage(hwnd, 103, BM_SETSTATE, (WPARAM) GetDlgItem(hwnd, 107),
      (LPARAM)(char far *) "Has no tabstop");
    SendDlgItemMessage(hwnd, 104, BM_SETSTATE, (WPARAM) GetDlgItem(hwnd, 107),
      (LPARAM)(char far *) "Enabled or disabled by button 5");
    SendDlgItemMessage(hwnd, 105, BM_SETSTATE, (WPARAM) GetDlgItem(hwnd, 107),
      (LPARAM)(char far *) "Enable or disable button 4");

    ShowWindow(hwnd, nCmdShow == SW_SHOWMAXIMIZED ? SW_SHOW : nCmdShow);
    UpdateWindow(hwnd);

    while (GetMessage(&msg, NULL, 0, 0))
      if (!IsDialogMessage (hwnd, &msg))
          DispatchMessage (&msg);

    return msg.wParam;
}


