//     (C) Copyright Microsoft Corp. 1991.  All rights reserved.
//
//     You have a royalty-free right to use, modify, reproduce and 
//     distribute the Sample Files (and/or any modified version) in 
//     any way you find useful, provided that you agree that 
//     Microsoft has no warranty obligations or liability for any 
//     Sample Application Files which are modified. 

/****************************************************************************

    MODULE    : SNDPLY.C

    PURPOSE   : DLL that exports functions helpfull in playing sounds
		using MCI.

    FUNCTIONS : LibMain
		WEP
		SndPlaySnd
		ErrorProc

    COMMENTS  : This DLL implements playing wavefiles through the MCI command
		interface.

    HISTORY   :

****************************************************************************/

#include <windows.h>
#include <stdio.h>
#include "plysnd.h"
#include <mmsystem.h>


HANDLE hInst;

// forward declarations

BOOL FAR PASCAL SndPlaySnd(HWND,LPSTR);
void FAR PASCAL ErrorProc(DWORD);


/****************************************************************************

    FUNCTION  :  LibMain(HANDLE,WORD,WORD,LPSTR)

    PURPOSE   : Initializes the heap of the DLL.

    COMMENTS  : This DLL implements playing wavefiles through the MCI command
		interface.

    HISTORY   :

****************************************************************************/

BOOL FAR PASCAL LibMain(hInstance,wDataSeg,cbHeap,lpszCmdLine)

HANDLE hInstance;
WORD   wDataSeg;
WORD   cbHeap;
LPSTR	lpszCmdLine;

{
     if (cbHeap == 0)
	return 0;

     hInst=hInstance;

     LocalInit(wDataSeg, 0 , (WORD)cbHeap);
}


/****************************************************************************

    FUNCTION  :  WEP (int)

    PURPOSE   : Windows Exit Procedure.  This function is called when the
		DLL exits.

    COMMENTS  :  This function must be included in all DLL's.  In low memory
		 situations the DLL could crash in the WEP so it is necessary
		 to place the WEP in a fixed (non-discardable) segment.

    HISTORY   :

****************************************************************************/



VOID FAR PASCAL WEP (bSystemExit)
int  bSystemExit;
{
    return;
}



/****************************************************************************

    FUNCTION  :  SndPlaySnd(HWND,LPSTR)

    PURPOSE   :  This function demonstrates how to use the function
		 sndPlaySound.	This is the easiest way to play a wave file.

    COMMENTS  :  The one setback to using sndPlaySound is that the entire
		 sound is loaded into memory at once.  If you have a very
		 large sound sndPlaySound will fail if the sound will not
		 load into physical memory.

    HISTORY   :

****************************************************************************/

BOOL FAR PASCAL SndPlaySnd(hWnd,lpWavefile)

HWND hWnd;
LPSTR lpWavefile;


{
     DWORD dwFlags;



     MessageBox(NULL,lpWavefile,(LPSTR)"Playing Wave File",MB_OK);


     dwFlags=SND_ASYNC;

     if (sndPlaySound(lpWavefile,dwFlags))
	   return(TRUE);
     else
	   return(FALSE);

}
