//*************************************************************
//  File name: res.h
//
//  Description: 
//      header file for resources and resource types
//
//  History:    Date       Author     Comment
//               1/21/92   MSM        Created
//
// Written by Microsoft Product Support Services, Windows Developer Support
// Copyright (c) 1992 Microsoft Corporation. All rights reserved.
//*************************************************************


//*** Dialog control IDs
#define IDL_NAMES       0x100    

//*** Structure definitions
typedef struct
{
    PEXEINFO    pExeInfo;
    PRESTYPE    prt;
    PRESINFO    pri;
    LONG        lSize;
    LPSTR       lpMem;
    int         fFile;
} RESPACKET, FAR *LPRESPACKET;

typedef struct
{
    WORD    wBytes;
    WORD    wTypeOrd;
    WORD    wIDOrd;
//  char    szType[];
//  char    szID[];

} NAMEENTRY, FAR *LPNAMEENTRY;

typedef struct
{
    BYTE    bWidth;         // Width in pixels
    BYTE    bHeight;        // Height in pixels
    BYTE    bColorCount;    // Number of colors
    BYTE    bReserved;      // Reserved
    WORD    wPlanes;        // Number of color planes
    WORD    wBitCount;      // Number of bits per pixel    
    DWORD   dwBytesInRes;   // size of resource in bytes
    DWORD   dwImageOffset ; // Offset of icon image from start of file
} ICONENTRY, FAR *LPICONENTRY;

typedef struct
{
    WORD    wReserved;      // reserved, 0
    WORD    wType;          // Type (3 for icons)
    WORD    wCount;         // Number of Icons in the Icons[] array
    ICONENTRY Icons[1];     // More than 1 at run-time, but this
                            // Sets up the array header for the compiler
} ICONDIR, FAR *LPICONDIR;

typedef struct
{
    BYTE    bWidth;         // Width in pixels
    BYTE    bHeight;        // Height in pixels
    BYTE    bColorCount;    // Reserved. Must be 0
    BYTE    bReserved;      // Reserved. Must be 0
    WORD    wXHotspot;
    WORD    wYHotspot;
    DWORD   lBytesInRes;   // size of resource in bytes
    DWORD   dwImageOffset; // Offset to cursor image from start of file
} CURSORENTRY, FAR *LPCURSORENTRY;

typedef struct
{
    WORD    wReserved;      // reserved, 0
    WORD    wType;          // Type (3 for icons)
    WORD    wCount;         // Number of Icons in the Icons[] array
    CURSORENTRY Cursors[1]; // More than 1 at run-time, but this
                            // Sets up the array header for the compiler
} CURSORDIR, FAR *LPCURSORDIR;

typedef struct
{
    int         xHotSpot;
    int         yHotSpot;
    BITMAPINFO  bi;
} CURSORIMAGE, FAR *LPCURSORIMAGE;

#define AF_VIRTKEY  0x01
#define AF_NOINVERT 0x02
#define AF_SHIFT    0x04    
#define AF_CONTROL  0x08
#define AF_ALT      0x10

#define WIDTHBYTES(bits)      (((bits) + 31) / 32 * 4)

//*** function prototypes
//*** bmp.c
BOOL ShowBitmap (LPRESPACKET );
LONG FAR PASCAL ShowBitmapProc (HWND, WORD, WORD, LONG);
HBITMAP MakeBitmap (LPRESPACKET, LPBITMAPFILEHEADER );
HPALETTE CreateNewPalette  (LPSTR, WORD, WORD);

//*** res.c
BOOL DisplayResource (PEXEINFO, PRESTYPE, PRESINFO );
BOOL SaveResource ( LPSTR, LONG, LPSTR, WORD );

//*** iconcur.c
BOOL FAR PASCAL ShowIconProc (HWND, WORD, WORD, LONG);
HICON   MakeIcon ( LPRESPACKET, LPICONDIR );

BOOL FAR PASCAL ShowCursorProc (HWND, WORD, WORD, LONG);
HCURSOR MakeCursor ( LPRESPACKET, LPCURSORDIR );

//*** EOF: res.h
