#include <errno.h>
#include <sys/doscalls.h>



/*
** AH = 0x3B
** DS:DX name (64 bytes)
*/
int dos_chdir(const char *name)
{
    struct REGPACK r;
    struct SEGPACK sr = { GetDS(), GetES()};

    r.eax = 0x3B00;
    SET_SEG_OFF(name, sr.ds, r.edx);

    _intxr(0x21, &r, &sr);

    if (r.eflags & 1) {
	_sys_doserror2errno( r.eax & 0xFFFF);
	return (-1);
    }
    else
	return (0);
}
