#include <errno.h>
#include <sys/doscalls.h>


/*
** AH = 0x3F
** BX = handle
** CX = bytes
** DS:DX = buf
** return: AX bytes
*/
int dos_read(int handle, void *buf, unsigned bytes)
{
    struct REGPACK r;
    struct SEGPACK sr = { GetDS(), GetES()};

    r.eax = 0x3F00;
    r.ebx = handle;
    r.ecx = bytes;
    SET_SEG_OFF(buf, sr.ds, r.edx);

    _intxr(0x21, &r, &sr);

    if (r.eflags & 1) {
	_sys_doserror2errno( r.eax & 0xFFFF);
	return (-1);
    }
    else
	return (r.eax & 0xFFFF);
}
