#include <errno.h>
#include <sys/doscalls.h>


/*
** AH = 0x42
** AL = orgin
** BX = handle
** CX:DX = pos
** return: new pos
*/
long dos_lseek(int handle, long offset, int orgin)
{
    struct REGPACK r;

    r.eax = 0x4200 | (char) orgin;
    r.ebx = handle;
    r.ecx = offset >> 16;
    r.edx = offset & 0xFFFF;

    _intr(0x21, &r);

    if (r.eflags & 1) {
	_sys_doserror2errno( r.eax & 0xFFFF);
	return (-1L);
    }
    else
	return (r.edx << 16) | (r.eax & 0xFFFF);
}
