#include <errno.h>
#include <sys/doscalls.h>

/*
** AH = 0x43 ; AL = 1
** CX = attr
** DS:DX name
*/
int dos_setfattr(const char *name, int attr)
{
    struct REGPACK r;
    struct SEGPACK sr = { GetDS(), GetES()};

    r.eax = 0x4301;
    r.ecx = attr;
    SET_SEG_OFF(name, sr.ds, r.edx);

    _intxr(0x21, &r, &sr);

    if (r.eflags & 1) {
	_sys_doserror2errno( r.eax & 0xFFFF);
	return (-1);
    }
    else
	return (r.eax & 0xFFFF);
}
