#include <errno.h>
#include <sys/doscalls.h>


/*
** AH = 0x46
** BX = handle
** CX = new handle
** return: -1 on error
*/
int dos_dup2(int handle, int newhandle)
{
    struct REGPACK r;

    r.eax = 0x4600;
    r.ebx = handle;
    r.ecx = newhandle;

    _intr(0x21, &r);

    if (r.eflags & 1) {
	_sys_doserror2errno( r.eax & 0xFFFF);
	return (-1);
    }
    else
	return (newhandle);
}
