#include <errno.h>
#include <sys/doscalls.h>


/*
** AH = 0x56
** DS:DX name (64 bytes)
** ES:DI name (64 bytes)
*/
int dos_rename(const char *oldname, const char *newname)
{
    struct REGPACK r;
    struct SEGPACK sr;

    r.eax = 0x5600;
    SET_SEG_OFF(oldname, sr.ds, r.edx);
    SET_SEG_OFF(newname, sr.es, r.edi);

    _intxr(0x21, &r, &sr);

    if (r.eflags & 1) {
	_sys_doserror2errno( r.eax & 0xFFFF);
	return (-1);
    }
    else
	return (0);
}
