#include <errno.h>
#include <sys/doscalls.h>


/*
** AH = 0x5B
** CX = attr
** DS:DX = name
** return: AX fileno
*/
int dos_creatnew(const char *name, int attr)
{
    struct REGPACK r;
    struct SEGPACK sr = { GetDS(), GetES()};

    r.eax = 0x5B00;
    r.ecx = attr;
    SET_SEG_OFF(name, sr.ds, r.edx);

    _intxr(0x21, &r, &sr);

    if (r.eflags & 1) {
	_sys_doserror2errno( r.eax & 0xFFFF);
	return (-1);
    }
    else
	return (r.eax & 0xFFFF);
}
