// rtabdial.cpp : implementation file
//

#include "stdafx.h"
#include "rtab_sam.h"
#include "..\include\rip_tabs.h"
#include "rtab_doc.h"
#include "rtab_vw.h"
#include "rtabdial.h"
#include "subclass.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

CVertRTabDialog::CVertRTabDialog(CWnd* pParent /*=NULL*/, BOOL SquareTabs)
	: CRTabDialog(pParent, SquareTabs, TRUE)
{
	//{{AFX_DATA_INIT(CRTabDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	MyView = (CRtab_samView*)pParent;
}

/////////////////////////////////////////////////////////////////////////////
// CRTabDialog dialog

CRTabDialog::CRTabDialog(CWnd* pParent /*=NULL*/, BOOL SquareTabs, BOOL bVert)
	: CTabDialog(CRTabDialog::IDD, pParent, 0, FALSE, SquareTabs, bVert)
{
	//{{AFX_DATA_INIT(CRTabDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	MyView = (CRtab_samView*)pParent;
}

CRTabDialog::~CRTabDialog()
{

	// Clean up our lists
	delete BitmapList;
	delete TabTextColorList;
	
	// Clean up our bitmaps
	DeleteObject(hBitmap1);
	DeleteObject(hBitmap2);
	DeleteObject(hBitmap3);
	DeleteObject(hBitmap4);
	DeleteObject(hBitmap5);
	DeleteObject(hBitmap6);
}


void CRTabDialog::DoDataExchange(CDataExchange* pDX)
{
	CTabDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRTabDialog)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	DDX_Text(pDX, IDC_EDITBOX, MyView->EditControlStatus);
	DDX_Control(pDX, IDC_EDITBOX, m_EditControl);
}

BEGIN_MESSAGE_MAP(CRTabDialog, CTabDialog)
	//{{AFX_MSG_MAP(CRTabDialog)
	ON_BN_CLICKED(IDHELP, OnClickedHelp)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BROWSE, OnClickedBrowse)
	ON_BN_CLICKED(IDC_CHANGETEXT, OnChangeText)
	ON_BN_CLICKED(IDC_DISABLE, OnDisableTab)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRTabDialog message handlers

BOOL CRTabDialog::OnInitDialog()
{
  // Load our bitmaps
  hBitmap1=LoadBitmap(AfxGetInstanceHandle(),"TABBITMAP");
  hBitmap2=LoadBitmap(AfxGetInstanceHandle(),"ARROW");
  hBitmap3=LoadBitmap(AfxGetInstanceHandle(),"ABC");
  hBitmap4=LoadBitmap(AfxGetInstanceHandle(),"GRAPH");
  hBitmap5=LoadBitmap(AfxGetInstanceHandle(),"DRAW");
  hBitmap6=LoadBitmap(AfxGetInstanceHandle(),"RIP");
  

  // Create our lists
  DlgOptionsList[0]= new CPtrArray();
  DlgOptionsList[0]->SetSize(0, 20);
  DlgOptionsList[1]= new CPtrArray();
  DlgOptionsList[1]->SetSize(0, 20);
  BitmapList= new CWordArray();
  BitmapList->SetSize(0, 20);
  TabTextColorList= new CDWordArray();
  TabTextColorList->SetSize(0, 20);

  
	// Build up our lists : tab titles
	DlgOptionsList[0]->Add((void*)CStringPtr("Radio Buttons"));
	DlgOptionsList[0]->Add((void*)CStringPtr("Check Boxes"));
	DlgOptionsList[0]->Add((void*)CStringPtr("Edit Control"));
	DlgOptionsList[0]->Add((void*)CStringPtr("Demos"));
	DlgOptionsList[0]->Add((void*)CStringPtr("List Box"));
	DlgOptionsList[0]->Add((void*)CStringPtr("About..."));
								
	// Build up our lists : child dialog identifiers
	DlgOptionsList[1]->Add((void*)CStringPtr("RADIO_DIALOG"));
	DlgOptionsList[1]->Add((void*)CStringPtr("CHECK_DIALOG"));
	DlgOptionsList[1]->Add((void*)CStringPtr("EDIT_DIALOG"));
	DlgOptionsList[1]->Add((void*)CStringPtr("DEMO_DIALOG"));
	DlgOptionsList[1]->Add((void*)CStringPtr("LIST_DIALOG"));
	DlgOptionsList[1]->Add((void*)CStringPtr("ABOUT_DIALOG"));

	// Build up our lists : tab bitmaps
	BitmapList->Add((WORD)hBitmap1);
	BitmapList->Add((WORD)hBitmap2);
	BitmapList->Add((WORD)hBitmap3);
	BitmapList->Add((WORD)hBitmap4);
	BitmapList->Add((WORD)hBitmap5);
	BitmapList->Add((WORD)hBitmap6);

	// Build up our lists : tab title text colora
	TabTextColorList->Add(RGB(0,0,255));
	TabTextColorList->Add(RGB(255,77,166));
	TabTextColorList->Add(RGB(64,128,128));
	TabTextColorList->Add(RGB(0,54,108));
	TabTextColorList->Add(RGB(0,0,0));
	TabTextColorList->Add(RGB(128,128,0));
	

	CTabDialog::InitData(
												DlgOptionsList[0], // tab titles
												DlgOptionsList[1], // Child dialog identifiers
												IDC_RSTATIC,       // ID of the group box on master dialog
												5, 								 // Maximum tabs per line
												BitmapList,        // list of bitmaps
												TabTextColorList,  // list of tab title text colors
												STDFont, 					 // Tab title text font
												STDFont, 					 // Active tab title text font
												STDFont, 					 // dialog controls font
												RGB(255, 0, 0),		 // Active tab text color
												3									 // Initial active tab
											);

	CTabDialog::OnInitDialog();
	
	// place your own controls intialization code here ...	
	// (*after* calling CTabDialog::InitData & OnInitDialog)  
	
	SendDlgItemMessage(IDC_LIST1, LB_ADDSTRING, 0, (LONG)"Item 1");
	SendDlgItemMessage(IDC_LIST1, LB_ADDSTRING, 0, (LONG)"Item 2");
	SendDlgItemMessage(IDC_LIST1, LB_ADDSTRING, 0, (LONG)"Item 3");
	SendDlgItemMessage(IDC_LIST1, LB_ADDSTRING, 0, (LONG)"Item 4");
	
	// To put data into dialog controls with DDX, be sure
	// to add an UpdateData call like we have done below.
	// Again, this should come AFTER calls to InitData
	// and OnInitData.
	MyView->EditControlStatus="Sample Text";
	UpdateData(FALSE);  
	
	// return *0* if you want the focus set to the control
	// that RipTABS has selected.  (Recommended)
	return 0;  
}

void CRTabDialog::OnOK()
{
	CString CheckBoxStatus, RadioButtonStatus, EditControlStatus;
	
	// If you are using DDX, remember to 
	// call Update Data here
	UpdateData(TRUE);

	if(IsDlgButtonChecked(IDC_CHECK1))
		MyView->CheckBoxStatus = "1";
	if(IsDlgButtonChecked(IDC_CHECK2))
		MyView->CheckBoxStatus = "2";
	if(IsDlgButtonChecked(IDC_CHECK3))
		MyView->CheckBoxStatus = "3";

	if(IsDlgButtonChecked(IDC_RADIO1))
		MyView->RadioButtonStatus = "1";
	if(IsDlgButtonChecked(IDC_RADIO2))
		MyView->RadioButtonStatus = "2";
	if(IsDlgButtonChecked(IDC_RADIO3))
		MyView->RadioButtonStatus = "3";
	
	CTabDialog::OnOK();
}

void CRTabDialog::OnClickedHelp()
{
	CString MessageText="Display Help For : ";
	MessageText+=ActivePage;
	MessageBox(MessageText, "RipTABS Sample");
}

void CRTabDialog::OnClickedBrowse()
{
	CRTabDialog diag(MyView);
	diag.DoModal();
}

void CRTabDialog::OnChangeText()
{
	if(GetTabText(1)=="Hi!")
		SetTabText(1, "Check Boxes");
	else
		SetTabText(1, "Hi!");
}

void CRTabDialog::OnDisableTab()
{
	if(IsTabEnabled(1))
		DisableTab(1);
	else
		EnableTab(1);
}

void CRTabDialog::OnCancel()
{
	// TODO: Add extra cleanup here
	CTabDialog::OnCancel();
}


void CRTabDialog::SwitchToNotification(int TabIndex, CString* TabName)
{
	// Here's where we grab the text of the
	// tab the user just switched to.  We
	// use this for our simple help system.
	ActivePage= *TabName;
}


/////////////////////////////////////////////////////////////////////////////
// CRTabMDialog MODELESS dialog

CRTabMDialog::CRTabMDialog(CWnd* pParent /*=NULL*/)
	: CTabDialog(0, FALSE, FALSE, TRUE)
{
	//{{AFX_DATA_INIT(CRTabDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	MyView = (CRtab_samView*)pParent;
	Create(CRTabMDialog::IDD, pParent);
}


void CRTabMDialog::DoDataExchange(CDataExchange* pDX)
{
	CTabDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRTabDialog)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRTabMDialog, CTabDialog)
	//{{AFX_MSG_MAP(CRTabDialog)
	ON_BN_CLICKED(IDHELP, OnClickedHelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRTabDialog message handlers

BOOL CRTabMDialog::OnInitDialog()
{
  DlgOptionsList[0]= new CPtrArray();
  DlgOptionsList[0]->SetSize(0, 20);
  DlgOptionsList[1]= new CPtrArray();
  DlgOptionsList[1]->SetSize(0, 20);

  
	DlgOptionsList[0]->Add((void*)CStringPtr("Radio Buttons"));
	DlgOptionsList[0]->Add((void*)CStringPtr("Check Boxes"));
	DlgOptionsList[0]->Add((void*)CStringPtr("Edit Control"));
	DlgOptionsList[0]->Add((void*)CStringPtr("Demos"));
	DlgOptionsList[0]->Add((void*)CStringPtr("List Box"));
	DlgOptionsList[0]->Add((void*)CStringPtr("About..."));
								
	DlgOptionsList[1]->Add((void*)CStringPtr("RADIO_DIALOG"));
	DlgOptionsList[1]->Add((void*)CStringPtr("CHECK_DIALOG"));
	DlgOptionsList[1]->Add((void*)CStringPtr("EDIT_DIALOG"));
	DlgOptionsList[1]->Add((void*)CStringPtr("DEMO_DIALOG"));
	DlgOptionsList[1]->Add((void*)CStringPtr("LIST_DIALOG"));
	DlgOptionsList[1]->Add((void*)CStringPtr("ABOUT_DIALOG"));
	

	CTabDialog::InitData(
												DlgOptionsList[0], 
												DlgOptionsList[1], 
												IDC_RSTATIC, 
												2, 
												NULL, 
												NULL, 
												STDFont, 
												STDFont, 
												STDFont
											);

	CTabDialog::OnInitDialog();
	
	// place your own controls intialization code here ...	
	// (*after* calling CTabDialog::InitData & OnInitDialog)
	
	return FALSE;
}

void CRTabMDialog::OnOK()
{
	char str[101];
	CString CheckBoxStatus, RadioButtonStatus, EditControlStatus;

	if(IsDlgButtonChecked(IDC_CHECK1))
		MyView->CheckBoxStatus = "1";
	if(IsDlgButtonChecked(IDC_CHECK2))
		MyView->CheckBoxStatus = "2";
	if(IsDlgButtonChecked(IDC_CHECK3))
		MyView->CheckBoxStatus = "3";

	if(IsDlgButtonChecked(IDC_RADIO1))
		MyView->RadioButtonStatus = "1";
	if(IsDlgButtonChecked(IDC_RADIO2))
		MyView->RadioButtonStatus = "2";
	if(IsDlgButtonChecked(IDC_RADIO3))
		MyView->RadioButtonStatus = "3";
	
	GetDlgItemText(IDC_EDITBOX, str, 100);
	MyView->EditControlStatus = str;

	CTabDialog::OnOK();
}

void CRTabMDialog::OnClickedHelp()
{
	CString MessageText="Display Help For : ";
	MessageText+=ActivePage;
	MessageBox(MessageText, "RipTABS Sample");
}

void CRTabMDialog::OnCancel()
{
	// TODO: Add extra cleanup here
	
	CTabDialog::OnCancel();
}

void CRTabMDialog::SwitchToNotification(int TabIndex, CString* TabName)
{
	ActivePage= *TabName;
}
                                    
void CRTabMDialog::PostNcDestroy()
{
	delete this;
}

