#include "winexp.inc"

void SetScroll (int depth, int pos)
{
    static int Enabled = FALSE;
    int delta = FALSE;


    if (depth == 0) return;

    if (Scroll_Offset != pos) {
        Scroll_Offset = pos;
        delta = TRUE;
        }

    if (Scroll_Depth != depth) {
        Scroll_Depth = depth;
        delta = TRUE;
        }

    if (Scroll_Offset > Scroll_Depth - (WindowHeight - NonScrollLines)) {
        Scroll_Offset = Scroll_Depth - (WindowHeight - NonScrollLines);
        delta = TRUE;
        }

    if (Scroll_Offset < 0) {
        Scroll_Offset = 0;
        delta = TRUE;
        }

    if (Scroll_Depth <= WindowHeight-NonScrollLines) { /* Should be off       */
        if (Enabled) {                  /* Its on, turn it off                */
            Enabled = FALSE;
            SetScrollRange (hMainWnd, SB_VERT, 0, 0, TRUE); /* Disable scroll */
            }
        }
    else                                /* Should be on                       */
        if (delta || !Enabled) {        /* If changed or not on yet           */
            Enabled = TRUE;
            SetScrollRange (hMainWnd, SB_VERT, 0, Scroll_Depth-(WindowHeight-NonScrollLines), FALSE);
            SetScrollPos (hMainWnd, SB_VERT, Scroll_Offset, TRUE);
            }
}
/*                                                                            */
/*  Value is a zero based item number that can range from 0 to Scroll_Depth   */
/*  This routine will return TRUE if the value is not displable               */
/*                                                                            */
BOOL OutOfVisibleRange (int value)
{
    if (value < Scroll_Offset) return TRUE;
    if (value >= Scroll_Offset+(WindowHeight-NonScrollLines)) return TRUE;
    return FALSE;
}

int Get_NonScrollLines (int choice)
{
    switch (choice) {
        case C_ACTIVE_VMS:  return 2;
        case C_VMHANDLE:    return 2;
        case C_TIMESLICE:   return 8;
        }
    return 0;
}

int Get_Scroll_Depth (int choice)
{
    DWORD   SysHandle;
    DWORD   Handle;
    int     i;

    switch (choice) {
        case C_TIMESLICE:
        case C_ACTIVE_VMS:
            Handle = SysHandle = Get_Sys_VM_Handle ();
            for (i=1; (Handle=Get_Next_VM_Handle (Handle)) != SysHandle; ++i);
            return i;
/*                                                                            */
/*  Fixed value for depth                                                     */
/*                                                                            */
        case C_VMHANDLE:
            if (OS_Type == WINDOWS31_OS)
                for (i=0; vmcb[i].str != NULL; ++i);
            if (OS_Type == WINDOWS31_DEBUG_OS)
                for (i=0; vmcb_debug[i].str != NULL; ++i);
            return i;
        }
    return 0;
}
