/***********************************************************************
   File "Sublocal.c"

   "Private heap implementation "

   Written By Daniel Appleman

   Copyright (c) 1992 by Desaware

************************************************************************/

/* This file allows use of LocalAlloc, LocalFree, LocalSize, LocalFree
   and LocalUnlock for private data segments.  It must be compiled under 
   a compiler that supports the use of the _asm keyword.
*/

#include "wdefall.h"
#undef KERNEL
#undef NOMEMMGR
#include "windows.h"

/* LocalInit does not need to be handled */

// hseg is the segment (selector) of the global block used as a heap

DWORD DSLocalAlloc(WORD hseg, WORD size)
{
   LOCALHANDLE hmem;
   _asm {
      push ds
      mov   ax, hseg
      mov   ds, ax
      }
   hmem = LocalAlloc(LMEM_MOVEABLE | LMEM_ZEROINIT, size);
   _asm { pop ds }
   return(MAKELONG(hmem, hseg));
}

// lhnd in this function and those following is the global heap selector
// in the high word and the local heap handle in the low word

short DSLocalFree(DWORD lhnd)
{
   WORD hseg;
   LOCALHANDLE hmem;
   hseg = HIWORD(lhnd);
   hmem = (LOCALHANDLE)LOWORD(lhnd);
   _asm {
      push ds
      mov   ax, hseg
      mov   ds, ax
      }
   LocalFree(hmem);
   _asm { pop ds }
   return(0);
}

WORD DSLocalSize(DWORD lhnd)
{
   WORD hseg;
   LOCALHANDLE hmem;
   WORD size;
   hseg = HIWORD(lhnd);
   hmem = (LOCALHANDLE)LOWORD(lhnd);
   _asm {
      push ds
      mov   ax, hseg
      mov   ds, ax
      }
   size=LocalSize(hmem);
   _asm { pop ds }
   return(size);
}


LPVOID DSLocalLock(DWORD lhnd)
{
   WORD hseg;
   LOCALHANDLE hmem;
   NPSTR ptr;
   hseg = HIWORD(lhnd);
   hmem = (LOCALHANDLE)LOWORD(lhnd);
   _asm {
      push ds
      mov   ax, hseg
      mov   ds, ax
      }
   ptr=LocalLock(hmem);
   _asm { pop ds }
   return((LPSTR)(MAKELONG(ptr, hseg)));
}

BOOL DSLocalUnlock(DWORD lhnd)
{
   WORD hseg;
   LOCALHANDLE hmem;
   BOOL p;
   hseg = HIWORD(lhnd);
   hmem = (LOCALHANDLE)LOWORD(lhnd);
   _asm {
      push ds
      mov   ax, hseg
      mov   ds, ax
      }
   p=LocalUnlock(hmem);
   _asm { pop ds }
   return(p);
}
