///////////////////////////////////////////////////////////////////////////////////////
// projet	SrcMngr	:	Quelques fonctions utiles
//	Dev.	COLLIN Grard,	Dbut le 08.06.94
///////////////////////////////////////////////////////////////////////////////////////

#include	"stdafx.h"
#include	<libgege\cmemory.h>
#include	<libgege\cnewmem.h>
#include	"utilfunc.h"
#include	<direct.h>

//%%SrCtl:UtilFunc%%

CString	CalculatePath	(CString	&RootDir,CString	&Path,CString	&Src)
	{
	CString	FileName;
	
    if	(RootDir[RootDir.GetLength()-1]=='\\')
		FileName=Src.Mid	(RootDir.GetLength());
	else
	    FileName=Src.Mid	(RootDir.GetLength()+1);

	return	MakePath	(Path,FileName);
	}

void	CreatePath	(LPCSTR	FilePath)
	{
	int	Current,Diff=0;
	CString	Extract,Path,ToSearch;
	
	Path=FilePath;
	ToSearch=Path;
	while	((Current=ToSearch.Find	('\\'))!=-1)
		{
		Diff=Diff+Current+1;
		Extract=Path.Left	(Diff-1);
		if	((Extract.Find(':')==-1)||((Extract.Find(':')!=-1)&&(Extract.GetLength()>3)))
			{
			_mkdir	(Extract);
			}
		ToSearch=Path.Mid	(Diff);
		}
	}
	

BOOL	CopyFile (LPCSTR Source,LPCSTR Dest)
	{
       CFile src,dest;
       
       if (_stricmp(Source,Dest)==0) return FALSE;
       if (src.Open(Source,CFile::modeRead|CFile::shareDenyWrite))
         {
         CFileException	CannotOpen;
         if (dest.Open(Dest,CFile::modeCreate | CFile::modeWrite |CFile::shareExclusive,&CannotOpen)==0)
            {
            if	(CannotOpen.m_cause==CFileException::badPath)
            	{
	            CreatePath	(Dest);			//Essaie de crer le chemin du fichier destination
	            if	(dest.Open(Dest,CFile::modeCreate | CFile::modeWrite |CFile::shareExclusive)==0)
	            	{
	            	src.Close	();
	            	return	FALSE;
	            	}
	            }
            }
          
         DWORD      taille    = src.GetLength();
         DWORD		MaxTaille = 1000000UL,LeBug;
         if (taille>MaxTaille) taille=MaxTaille;
         HGLOBAL    BigBuf    = GlobalAlloc(GHND,taille);
         if (BigBuf==NULL)
         	return FALSE;
         char huge* BufferPtr = (char huge*)GlobalLock(BigBuf);
             
         while ((LeBug=src.ReadHuge(BufferPtr,taille))==taille)
           {
            dest.WriteHuge(BufferPtr,LeBug);
           }
             
         if	((LeBug!=taille)&&(LeBug>0))
         	dest.WriteHuge(BufferPtr,LeBug);
         GlobalUnlock(BigBuf);
         GlobalFree(BigBuf);
             
         dest.Close();
            
         src.Close();
         }
        else
         return FALSE;
     return TRUE;
     }

BOOL	CopyClasse	(CString& From,CString&	To,CString&	Classe)
	{
	CNewMem	Src,Dest,OldDest;
	BOOL	Ret=TRUE;
	
    TRY	{
    
	    if	((!Src.LoadFile(From))||(!OldDest.LoadFile(To)))
	    	return FALSE;
	    
	    if	(Dest.Realloc	(10)==FALSE)
	    	return FALSE;
	    	
	    
	    Ret=CopyBeforeClasse	(OldDest,Dest,Classe);
	    Ret&=WriteStartClasse	(Dest,Classe,0);
	    Ret&=CopyAllClasse		(Src,Dest,Classe);
	    Ret&=WriteEndClasse		(Dest,Classe,0);
	    
	    Ret&=CopyAfterClasse	(OldDest,Dest,Classe);
	    if	(Ret==TRUE)
	    	Ret=Dest.WriteFile		(To);
	    }
	CATCH(CFileException,e)
		{
		AfxMessageBox	("Erreur de fichier !!!");
		Src.Free  ();
		Dest.Free ();
		OldDest.Free	();
		return FALSE;
		}
	AND_CATCH(CException,t)
		{
		Src.Free  ();
		Dest.Free ();
		OldDest.Free	();
		return FALSE;
		}
	END_CATCH
	return Ret;
		
    }
    
BOOL	AddClassInFile	(char nType,CString& Classe,CString&	To)
	{
	CNewMem	Dest,OldDest;
	BOOL	Ret=TRUE,OldDestExist=TRUE;
	
    TRY	{
    
        TRY	{
	    	if	(!OldDest.LoadFile(To))
	    		OldDestExist=FALSE;
	    	}
	    CATCH(CFileException,e)
	    	{
	    	OldDestExist=FALSE;
	    	}
	    END_CATCH
	    
	    if	(Dest.Realloc	(10)==FALSE)
	    	return FALSE;
	    	
	    if	(OldDestExist)
	    	Ret=CopyBeforeClasse	(OldDest,Dest,Classe);
	    Ret&=WriteStartClasse	(Dest,Classe,0);
	    if	(nType=='H')
	    	Ret&=CreateHeaderClasse		(Dest,Classe);
	    else
	    	Ret&=CreateBodyClasse	(Dest,Classe);
	    Ret&=WriteEndClasse		(Dest,Classe,0);

		if	(OldDestExist)	    
	    	Ret&=CopyAfterClasse	(OldDest,Dest,Classe);
	    
	    if	(Ret==TRUE)
	    	Ret=Dest.WriteFile		(To);
	    }
	CATCH(CFileException,e)
		{
		AfxMessageBox	("Erreur de fichier !!!");
		Dest.Free ();
		OldDest.Free	();
		return FALSE;
		}
	AND_CATCH(CException,t)
		{
		Dest.Free ();
		OldDest.Free	();
		return FALSE;
		}
	END_CATCH
	return Ret;
    }

BOOL	CreateHeaderClasse	(CNewMem& Dest,CString& NomClasse)
	{
	CString	Ajoute,Cr;
	char	Temp[3]={13,10,0};
	
	Cr=Temp;
	
	Ajoute="//////////////////////////////////////////////////////////////////////////////////////"+Cr+"class "+NomClasse;
	Ajoute+=Cr+" {"+Cr+"  public:           //public members"+Cr;
	Ajoute+="   "+NomClasse+" ();"+Cr+"   virtual ~"+NomClasse+" ();";
	Ajoute+=Cr+"  protected:          //protected members"+Cr+Cr+" };"+Cr+Cr;
	return Dest.AddString	(Ajoute);
	}

BOOL	CreateBodyClasse	(CNewMem& Dest,CString& NomClasse)
	{
	CString	Ajoute,Cr;
	char	Temp[3]={13,10,0};
	
	Cr=Temp;
	
	Ajoute="//////////////////////////////////////////////////////////////////////////////////////"+Cr;
	Ajoute+=Cr+Cr+NomClasse+"::"+NomClasse+" ()"+Cr+" {"+Cr+Cr+" }"+Cr+Cr+NomClasse+"::"+"~"+NomClasse+"()"+Cr+" {"+Cr+Cr+" }"+Cr;
	return Dest.AddString	(Ajoute);
	}



BOOL	CopyBeforeClasse	(CNewMem& Src,CNewMem& Dest,CString& Classe)
	{
	CString	ToSearch;
	
	ToSearch="//%%SrCtl:"+Classe+"%%";
	
	if	(!Src.IsLocked())
		Src.GetDataPtr();
	Src.ResetPtr();		//Remet le pointeur au dbut
	
    if	(!Dest.IsLocked())
    	Dest.GetDataPtr();

	if	(Src.Search	(ToSearch))	//Trouve le dbut de classe
		{
		DWORD DebutClasse;
		
		DebutClasse=Src.GetCurrentPos();
		return Src.CopyTo	(Dest,0,DebutClasse);		//Et le copie
		}
	else
		{
					//La classe n'y est pas
		TRACE("Classe non trouve dans le fichier source\n");
		return Src.CopyTo	(Dest,0);
		}
	return TRUE;
	}


BOOL	CopyDebutFichier	(CString& pSrc,CString& pOldDest)
	{
	CString	ToSearch;
	CNewMem	Src,Dest,OldDest;
	
    TRY	{
    
	    if	((!Src.LoadFile(pSrc))||(!OldDest.LoadFile(pOldDest)))
	    	return FALSE;
	    
	    if	(Dest.Realloc	(10)==FALSE)
	    	return FALSE;
	    	
		ToSearch="//%%SrCtl:";
		
		Src.GetDataPtr();
		Src.ResetPtr();		//Remet le pointeur au dbut
		OldDest.GetDataPtr();
		
	    if	(!Dest.IsLocked())
	    	Dest.GetDataPtr();
	
		if	(Src.Search	(ToSearch))	//Trouve le dbut de classe
			{
			DWORD DebutClasse;
			
			DebutClasse=Src.GetCurrentPos();
			Src.CopyTo	(Dest,0,DebutClasse);		//Et le copie
			OldDest.ResetPtr();
			if	(OldDest.Search(ToSearch))
				{
				DWORD OldDebut;
					//Copie la suite du fichier
				OldDebut=OldDest.GetCurrentPos();
				OldDest.CopyTo	(Dest,OldDebut);
				}
			else
				{
				TRACE("\nErr CopyDebutFichier, Debut classe non trouve dans Old\n");
				
				return FALSE;
				}
			}
		else
			{
						//La classe n'y est pas
			TRACE("\nWrng Classe non trouve dans le fichier source\n");
			Src.CopyTo	(Dest,0);
			}
	     return Dest.WriteFile		(pOldDest);
		}
	CATCH(CFileException,e)
		{
		AfxMessageBox	("Erreur de fichier !!!");
		Src.Free  ();
		Dest.Free ();
		OldDest.Free	();
		return FALSE;
		}
	AND_CATCH(CException,t)
		{
		Src.Free  ();
		Dest.Free ();
		OldDest.Free	();
		return FALSE;
		}
	END_CATCH
	return TRUE;
	}


BOOL	CopyAfterClasse	(CNewMem& Src,CNewMem& Dest,CString& Classe)
	{
	CString	ToSearch;
	
	ToSearch="//%%EndSrCtl:"+Classe+"%%";
	
	if	(!Src.IsLocked())
		Src.GetDataPtr();
	
	Src.ResetPtr();
	if	(Src.Search	(ToSearch))	//Trouve la fin de classe (une seule par fichier)
		{
		DWORD DebutClasse,Pos;
		
		Pos=Src.GetCurrentPos();
		if	(Src.GotoEndLine()==FALSE)
			{
			TRACE("Err CopyAfterClasse, End of line not found");
			return FALSE;
			}
		DebutClasse=Src.GetCurrentPos()+2;
		return Src.CopyTo	(Dest,DebutClasse);		//Et le copie
		}
	else
		{
					//La classe n'y est pas
		TRACE("Classe non trouve dans le fichier source\n");
		return TRUE;
		}
	}


BOOL	CopyAllClasse	(CNewMem& Src,CNewMem& Dest,CString& Classe)
	{
	CString	ToSearch,EndSearch;
	
	ToSearch="//%%SrCtl:"+Classe+"%%";
	EndSearch="//%%EndSrCtl:"+Classe+"%%";
	if	(!Src.IsLocked())
		Src.GetDataPtr();
	Src.ResetPtr();		//Remet le pointeur au dbut
	
	while (Src.Search	(ToSearch))	//Trouve le dbut de classe
		{
		DWORD DebutClasse,FinClasse;
		
		DebutClasse=Src.GetCurrentPos();
			//Recherche la fin du commentaire
		if	(!Src.GotoEndLine	())
			{
			TRACE("\nErr CopyAllClasse, pas de fin de ligne");
			return FALSE;
		    }
		DebutClasse=Src.GetCurrentPos()+2;	//Va a la fin de la ligne
		
		if	(!Src.Search	(EndSearch))
			{
			TRACE("\nErr CopyAllClasse, Pas de fin de classe");
			return FALSE;
			}
		FinClasse=Src.GetCurrentPos();
		if	(!Src.CopyTo	(Dest,DebutClasse,FinClasse))		//Et le copie
			return FALSE;
		Src.MoveTo	(FinClasse);
		}
	return TRUE;	
	}



BOOL	WriteStartClasse	(CNewMem& Dest, CString& Classe, BOOL bLocked)
	{
	int		TailleClasse;
	CString	Info;
	if(!Dest.IsLocked())
		Dest.GetDataPtr();
	
    Info="//%%SrCtl:"+Classe;
    if	(bLocked)
    	Info+="%%Locked";
    else
    	Info+="%%";
    	
	TailleClasse=Info.GetLength()+2;
	if	(Dest.ReallocToAdd	(TailleClasse)==FALSE)
		return FALSE;
	Dest.AddString	(Info);
	 
	BYTE huge *Ptr;
	 
	Ptr=Dest.GetCurrentPtr	();
	 	//Saut de ligne :
	(*Ptr++)=13;
	(*Ptr++)=10;
	Dest.MoveTo(Dest.GetCurrentPos()+2);
	 
	return TRUE;
	}
		
BOOL	WriteEndClasse	(CNewMem& Dest, CString& Classe, BOOL bLocked)
	{
	int		TailleClasse;
	CString	Info;
	ASSERT(Dest.IsLocked());		//Doit tre lock
	
    Info="//%%EndSrCtl:"+Classe;
    if	(bLocked)
    	Info+="%%Locked";
    else
    	Info+="%%";
    	
	TailleClasse=Info.GetLength()+2;
	if	(Dest.ReallocToAdd	(TailleClasse)==FALSE)
		return FALSE;
	Dest.AddString	(Info);
	 
	BYTE huge *Ptr;
	 
	Ptr=Dest.GetCurrentPtr	();
	 	//Saut de ligne :
	(*Ptr++)=13;
	(*Ptr++)=10;
	Dest.MoveTo(Dest.GetCurrentPos()+2);
	 
	return TRUE;
	}
	
	
CString MakePath(const CString& fdir, const CString fname)
{
 if (fdir == "")
   {
    return fname;
   }
 else if (fdir[fdir.GetLength() - 1] != '\\')
   {
    return fdir + "\\" + fname;
   }
 else
   {
    return fdir + fname;
   }
}

void EmptyObArray(CObArray* parray)
{
 if (parray != NULL)
   {
    for (int i = 0; i < parray->GetSize(); i++)
       {
        delete parray->GetAt(i);        
       }
       
    parray->SetSize(0);
   }
}

//%%EndSrCtl:UtilFunc%%
