#include "winexp.inc"

struct vmstruct near vmcb[] = {
    "Status Flags       ",0x00,4,0,1,
    "Linear High Addr   ",0x04,4,0,1,
    "Client Regs        ",0x08,4,0,1,
    "VM Id              ",0x0C,2,0,1,
    "PM Int Table       ",0x10,4,0,1,
    "VM Exec Time       ",0x14,4,0,1,
    "V86 Page Table     ",0x18,4,0,1,
    "Local_Trap_Array[8]",0x1C,4,0,4,
    "                   ",0x2C,4,0,4,
    "Nested Exec List   ",0x3C,4,0,1,
    "OS_Stack           ",0x40,4,0,1,
    "Scheduler Flags    ",0x44,4,0,1,
    "Map Selector List  ",0x48,4,0,1,
    "LDT - Locked PM Stk",0x4E,2,0,1,
    "GDT - Locked PM Stk",0x50,2,0,1,
    "Saved SS           ",0x52,2,0,1,
    "Saved ESP          ",0x54,4,0,1,
    "hMem - Locked Stk  ",0x58,4,0,1,
    "PM Stack Usage cnt ",0x5C,4,0,1,
    "EIP - Locked PM Stk",0x60,4,0,1,
    "PM App CB          ",0x64,4,0,1,
    "VM List Link       ",0x68,4,0,1,
    "Next VM            ",0x6C,4,0,1,
    "VM Queue           ",0x70,4,0,1,
    "Blocked-On Sema    ",0x74,4,0,1,
    "Suspended Queue    ",0x78,4,0,1,
    "Suspended Blkd Sema",0x7C,4,0,1,
    "Execution Priority ",0x80,4,0,1,
    "Scheduler Status   ",0x84,4,0,1,
    "Suspended Stack    ",0x88,4,0,1,
    "TSS ESP0           ",0x8C,4,0,1,
    "hMem Stack         ",0x90,4,0,1,
    "Suspend Count      ",0x94,4,0,1,
    "Suspend Event      ",0x98,4,0,1,
    "Foreground TS prio ",0x9C,2,1,1,
    "Background TS Prio ",0x9E,2,1,1,
    "Weighted priority  ",0xA0,4,0,1,
    "Weighted Time      ",0xA4,4,0,1,
    "Next Scheduled VM  ",0xA8,4,0,1,
    "Last Time Weighed  ",0xAC,4,0,1,
    "DetailedErrorCode  ",0xB0,4,0,1,
    "Detailed Ref Data  ",0xB4,4,0,1,
    "PhysAddr of PageTbl",0xB8,4,0,1,
    "Instance Buffer    ",0xBC,4,0,1,
    "hMem for VM CB     ",0xC0,4,0,1,
    "hMem Instance Buf  ",0xC4,4,0,1,
    "Device V86 Pages[9]",0xC8,4,0,5,
    "                   ",0xDC,4,0,4,
    "V86 Pageable Array ",0xEC,4,0,4,
    "                   ",0xFC,4,0,4,
    "MMGR Flags         ",0x10C,4,0,1,
    "MMGR Pages         ",0x110,4,0,1,
    "LDT selector       ",0x114,2,0,1,
    " +0x116            ",0x116,2,0,1,
    "LDT hMem           ",0x118,4,0,1,
    "VM Event Count     ",0x11C,4,0,1,
    "VM Event List      ",0x120,4,0,1,
    "Priority VM List   ",0x124,4,0,1,
    "Int Enable Count   ",0x128,4,0,1,
    "Int Enable List    ",0x12C,4,0,1,
    "Next Timeout       ",0x130,4,0,1,
    "Prev Timeout       ",0x134,4,0,1,
    "1st timeout (mSec) ",0x138,4,0,1,
    "Time overrun (mSec)",0x13C,4,0,1,
    "IDT Base hMem      ",0x140,4,0,1,
    " +0x144            ",0x144,2,0,1,
    "IDT Limit          ",0x146,2,0,1,
    "IDT Base ptr       ",0x148,4,0,1,
    "Int 0 Exception    ",0x14C,6,0,1,
    "Int 1 Exception    ",0x152,6,0,1,
    "Int 2 Exception    ",0x158,6,0,1,
    "Int 3 Exception    ",0x15E,6,0,1,
    "Int 4 Exception    ",0x164,6,0,1,
    "Int 5 Exception    ",0x16A,6,0,1,
    "Int 6 Exception    ",0x170,6,0,1,
    "Int 7 Exception    ",0x176,6,0,1,
    "Int 8 Exception    ",0x17C,6,0,1,
    "Int 9 Exception    ",0x182,6,0,1,
    "Int A Exception    ",0x188,6,0,1,
    "Int B Exception    ",0x18E,6,0,1,
    "Int C Exception    ",0x194,6,0,1,
    "Int D Exception    ",0x19A,6,0,1,
    "Int E Exception    ",0x1A0,6,0,1,
    "Int F Exception    ",0x1A6,6,0,1,
    "Int 10 Exception   ",0x1AC,6,0,1,
    "Int 11 Exception   ",0x1B2,6,0,1,
    "Int 12 Exception   ",0x1B8,6,0,1,
    "Int 13 Exception   ",0x1BE,6,0,1,
    "Int 14 Exception   ",0x1C4,6,0,1,
    "Int 15 Exception   ",0x1CA,6,0,1,
    "Int 16 Exception   ",0x1D0,6,0,1,
    "Int 17 Exception   ",0x1D6,6,0,1,
    "Int 18 Exception   ",0x1DC,6,0,1,
    "Int 19 Exception   ",0x1E2,6,0,1,
    "Int 1A Exception   ",0x1E8,6,0,1,
    "Int 1B Exception   ",0x1EE,6,0,1,
    "Int 1C Exception   ",0x1F4,6,0,1,
    "Int 1D Exception   ",0x1FA,6,0,1,
    "Int 1E Exception   ",0x100,6,0,1,
    "Int 1F Exception   ",0x106,6,0,1,
    "V86 CallBack List  ",0x20C,4,0,1,
    NULL, 0,0,0,0
};

struct vmstruct near vmcb_debug[] = {
    "Status Flags       ",0x00,4,0,1,//
    "Linear High Addr   ",0x04,4,0,1,//
    "Client Regs        ",0x08,4,0,1,//
    "VM Id              ",0x0C,2,0,1,//
    "                   ",0x10,4,0,1,
    "PM Int Table       ",0x14,4,0,1,//
    "VM Exec Time       ",0x18,4,0,1,//
    "V86 Page Table     ",0x1C,4,0,1,//
    "Local_Trap_Array[8]",0x20,4,0,4,//
    "                   ",0x30,4,0,4,//
    "Nested Exec List   ",0x40,4,0,1,
    "OS_Stack           ",0x44,4,0,1,
    "Scheduler Flags    ",0x48,4,0,1,//
    "Map Selector List  ",0x4C,4,0,1,
    "LDT - Locked PM Stk",0x52,2,0,1,//
    "GDT - Locked PM Stk",0x54,2,0,1,//
    "Saved SS           ",0x56,2,0,1,//
    "Saved ESP          ",0x58,4,0,1,//
    "hMem - Locked Stk  ",0x5C,4,0,1,
    "PM Stack Usage cnt ",0x60,4,0,1,
    "EIP - Locked PM Stk",0x64,4,0,1,
    "PM App CB          ",0x68,4,0,1,
    "VM List Link       ",0x6C,4,0,1,//
    "Next VM            ",0x70,4,0,1,//
    "VM Queue           ",0x74,4,0,1,//
    "Blocked-On Sema    ",0x78,4,0,1,
    "Suspended Queue    ",0x7C,4,0,1,
    "Suspended Blkd Sema",0x80,4,0,1,
    "Execution Priority ",0x84,4,0,1,//
    "Scheduler Status   ",0x88,4,0,1,//
    "Suspended Stack    ",0x8C,4,0,1,//
    "TSS ESP0           ",0x90,4,0,1,//
    "hMem Stack         ",0x94,4,0,1,//
    "Suspend Count      ",0x98,4,0,1,//
    "Suspend Event      ",0x9C,4,0,1,
    "Foreground TS prio ",0xA0,2,1,1,//
    "Background TS Prio ",0xA2,2,1,1,//
    "Weighted priority  ",0xA4,4,0,1,
    "Weighted Time      ",0xA8,4,0,1,//
    "Next Scheduled VM  ",0xAC,4,0,1,
    "Last Time Weighed  ",0xB0,4,0,1,//
    "DetailedErrorCode  ",0xB4,4,0,1,
    "Detailed Ref Data  ",0xB8,4,0,1,
    "PhysAddr of PageTbl",0xC0,4,0,1,//
    "Instance Buffer    ",0xC4,4,0,1,//
    "hMem for VM CB     ",0xC8,4,0,1,//
    "hMem Instance Buf  ",0xCC,4,0,1,//
    "Device V86 Pages[9]",0xD0,4,0,5,//
    "                   ",0xE4,4,0,4,//
    "V86 Pageable Array ",0xF4,4,0,4,//
    "                   ",0x104,4,0,4,//
    "MMGR Flags         ",0x114,4,0,1,//
    "MMGR Pages         ",0x118,4,0,1,//
    "LDT selector       ",0x11C,2,0,1,//
    "LDT hMem           ",0x120,4,0,1,//
    "VM Event Count     ",0x124,4,0,1,//
    "VM Event List      ",0x128,4,0,1,
    "Priority VM List   ",0x12C,4,0,1,
    "Int Enable Count   ",0x130,4,0,1,//
    "Int Enable List    ",0x134,4,0,1,
    "Next Timeout       ",0x138,4,0,1,
    "Prev Timeout       ",0x13C,4,0,1,
    "1st timeout (mSec) ",0x140,4,0,1,
    "Time overrun (mSec)",0x144,4,0,1,
    "IDT Base hMem      ",0x148,4,0,1,
    "IDT Limit          ",0x14E,2,0,1,//
    "IDT Base ptr       ",0x150,4,0,1,//
    "Int 0 Exception    ",0x154,6,0,1,
    "Int 1 Exception    ",0x15A,6,0,1,
    "Int 2 Exception    ",0x160,6,0,1,
    "Int 3 Exception    ",0x166,6,0,1,
    "Int 4 Exception    ",0x16C,6,0,1,
    "Int 5 Exception    ",0x172,6,0,1,
    "Int 6 Exception    ",0x178,6,0,1,
    "Int 7 Exception    ",0x17E,6,0,1,
    "Int 8 Exception    ",0x184,6,0,1,
    "Int 9 Exception    ",0x18A,6,0,1,
    "Int A Exception    ",0x190,6,0,1,
    "Int B Exception    ",0x196,6,0,1,
    "Int C Exception    ",0x19C,6,0,1,
    "Int D Exception    ",0x1A2,6,0,1,
    "Int E Exception    ",0x1A8,6,0,1,
    "Int F Exception    ",0x1AE,6,0,1,
    "Int 10 Exception   ",0x1B4,6,0,1,
    "Int 11 Exception   ",0x1BA,6,0,1,
    "Int 12 Exception   ",0x1C0,6,0,1,
    "Int 13 Exception   ",0x1C6,6,0,1,
    "Int 14 Exception   ",0x1CC,6,0,1,
    "Int 15 Exception   ",0x1D2,6,0,1,
    "Int 16 Exception   ",0x1D8,6,0,1,
    "Int 17 Exception   ",0x1DE,6,0,1,
    "Int 18 Exception   ",0x1E4,6,0,1,
    "Int 19 Exception   ",0x1EA,6,0,1,
    "Int 1A Exception   ",0x1F0,6,0,1,
    "Int 1B Exception   ",0x1F6,6,0,1,
    "Int 1C Exception   ",0x1FC,6,0,1,
    "Int 1D Exception   ",0x202,6,0,1,
    "Int 1E Exception   ",0x208,6,0,1,
    "Int 1F Exception   ",0x20E,6,0,1,
    "V86 CallBack List  ",0x214,4,0,1,
    NULL, 0,0,0,0
};

void Display_Active_VMs ()
{
    DWORD   SysHandle;
    DWORD   Handle;
    WORD    VMId;
    char    AppName[33];
    int     VMs = 0;
    char    temp[80];

    if (VMM_Debug_Ver)
        wsprintf (temp, ", Debug Version %ld", VMM_Debug_Ver);
    else
        temp[0] = '\0';

    StringOut (0, "VMM Version %d.%d %s",VMMVerMaj, VMMVerMin, temp);
    StringOut (1, " ");

    SysHandle = Get_Sys_VM_Handle(); /* This will always be the same       */
    Handle = SysHandle;

    do {
        ++VMs;
        if (!OutOfVisibleRange (VMs-1)) {
            GetVMInfo (Handle, AppName, &VMId);
            VStringOut (VMs-1, "%2d: %08lX - %s", VMId, Handle, AppName);
            }
        }
    while ((Handle = Get_Next_VM_Handle (Handle)) != SysHandle);

    VStringOut (VMs, " ");
    SetScroll (VMs, Scroll_Offset);
}

void Display_VMHandle ()
{
    BYTE    *CBptr;
    BYTE    *bptr;
    WORD    *wptr;
    DWORD   *dptr;
    int     i, j;
    unsigned char buf1[90], buf2[16];
    int     scroll_max = Scroll_Offset+(WindowHeight-NonScrollLines);
    struct  vmstruct    *vmptr;

    vmptr = &vmcb;
    if (OS_Type == WINDOWS31_DEBUG_OS) vmptr = &vmcb_debug;

    StringOut (0, "Contents of VM: %08lX", VMHandle);
    StringOut (1, " ");
    if (OS_Type == WINDOWS31_OS)
        CBptr = Map_Linear (VMHandle, sizeof(VM_ControlBlock));
    else
        CBptr = Map_Linear (VMHandle, sizeof(VM_ControlBlock)+8);
    bptr = (BYTE  *) CBptr;
    for (i=0; vmptr[i].str != NULL && i<scroll_max; ++i) {
        if (i<Scroll_Offset) continue;
        wsprintf (buf1, "+%3Xh   %s :",vmptr[i].offset, vmptr[i].str);
        for (j=0; j<vmptr[i].repeat; ++j) {
            switch (vmptr[i].size) {
                case 2:                 /* 2 bytes (WORD)                     */
                    wptr = bptr+vmptr[i].offset+j*2;
                    switch (vmptr[i].format) {
                        case 0: wsprintf (buf2, "%04X  ",*wptr); break;
                        case 1: wsprintf (buf2, "%d  ",*wptr); break;
                        }
                    break;
                case 4:                 /* 4 bytes (DWORD)                    */
                    dptr = bptr+vmptr[i].offset+j*4;
                    switch (vmptr[i].format) {
                        case 0: wsprintf (buf2, "%08lX  ",*dptr); break;
                        case 1: wsprintf (buf2, "%d  ",*dptr); break;
                        }
                    break;
                case 6:
                    dptr = bptr+vmptr[i].offset+j*6;
                    wptr = bptr+vmptr[i].offset+j*6+4;
                    wsprintf (buf2, "%04X:%08lX", *wptr, *dptr);
                    break;
                }
            strcat (buf1, buf2);
            }
        VStringOut (i, buf1);
        }
    Free_Mapped_Linear (CBptr);
}

DWORD Get_nth_VM (int VM_num)
{
    int i;
    DWORD   Handle = Get_Sys_VM_Handle ();

    for (i=1; i<VM_num; ++i)
        Handle = Get_Next_VM_Handle (Handle);

    return Handle;
}

void Display_TimeSlice()
{
    DWORD   SysHandle;
    DWORD   Handle;
    WORD    VMId;
    char    AppName[33];
    int     VMs = 1;
    int     i;
    BYTE    *CBptr;
    char    strhandle[12];
    char    buf[100];
    DWORD   Cur_Sched;
    DWORD   Cur_Focus;
    DWORD   Sched_Count;
    DWORD   Sched_Idle;
    DWORD   fudge_factor = 0;

    if (OS_Type == WINDOWS31_DEBUG_OS) fudge_factor = 4;

    Cur_Focus = Get_Execution_Focus ();
    Get_Time_Slice_Info (&Sched_Count, &Cur_Sched, &Sched_Idle);
    StringOut (0, "%d VMs scheduled, %d scheduled VMs idle   ",
               Sched_Count,Sched_Idle);
    StringOut (1, "Current Scheduled VM %08lX,  Execution Focus VM %08lX",
               Cur_Sched, Handle = Cur_Focus);

    for (i=0, buf[0]='\0'; i<8 && Handle; ++i) {
        sprintf (strhandle, "%08lX->", Handle);
        strcat (buf, strhandle);
        Handle = Get_DWORD (Handle+0xA8+fudge_factor);  /* Next scheduled VM  */
        if (Handle && !Validate_VM_Handle (Handle)) {
            Error_Msg ("Next Scheduled VM field is not a valid VM Handle");
            SetChoice (TS_Choice, TS_Offset, TS_Highlight);
            return;
            }
        }
    if (i<8) strcat (buf,"00000000");
    StringOut (3, buf);

    SysHandle = Get_Sys_VM_Handle(); /* This will always be the same       */
    Handle = SysHandle;

    StringOut (6,"ID  VMHandle  VM Name               Weight    WieghTim  LastCalc  ExecTime");
    StringOut (7,"--  --------  --------------------  --------  --------  --------  --------");

    if (VMs > Scroll_Offset) {
        GetVMInfo (Handle, AppName, &VMId);
        CBptr = Map_Linear (Handle, sizeof(VM_ControlBlock));
        VStringOut (0, "%2d: %08lX  %-20s  %08lX  %08lX  %08lX  %08lX",
                   VMId, Handle, AppName,
                   *(DWORD*) (CBptr+0xA0+fudge_factor),
                   *(DWORD*) (CBptr+0xA4+fudge_factor),
                   *(DWORD*) (CBptr+0xAC+fudge_factor),
                   *(DWORD*) (CBptr+0x14+fudge_factor));
        Free_Mapped_Linear (CBptr);
        }

    while ((Handle = Get_Next_VM_Handle (Handle)) != SysHandle) {
        ++VMs;
        if (!OutOfVisibleRange (VMs-1)) {
            GetVMInfo (Handle, AppName, &VMId);
            CBptr = Map_Linear (Handle, sizeof(VM_ControlBlock));
            VStringOut (VMs-1, "%2d: %08lX  %-20s  %08lX  %08lX  %08lX  %08lX",
                        VMId, Handle, AppName,
                        *(DWORD*) (CBptr+0xA0+fudge_factor),
                        *(DWORD*) (CBptr+0xA4+fudge_factor),
                        *(DWORD*) (CBptr+0xAC+fudge_factor),
                        *(DWORD*) (CBptr+0x14+fudge_factor));
            Free_Mapped_Linear (CBptr);
            }
        }

    VStringOut (VMs, " ");
    SetScroll (VMs, Scroll_Offset);
}

void Error_Msg (char *str)
{
    MessageBox (hMainWnd, str, szAppName, MB_ICONEXCLAMATION | MB_OK);
}
